{Copyright:      Vlad Karpov  mailto:KarpovVV@protek.ru
 Author:         Vlad Karpov
 Remarks:        freeware, but this Copyright must be included

 Description:    MAPI components for Delphi

 Version:       V 1.0.1     03.03.2003
             1) add USE_DEFAULT flag in TMAPILogonFlags;
             2) Fix bug:
                     StrToDateTime('01.01.1601') ->
                     EncodeDate(1601, 1, 1)
                makes component independed from locale date format.
             3) Rename the 'MAPIX.pas' to 'VKMAPI.pas'
             4) Makes version for D5, D6, D7 in one packege.

                      Thanks Darryl West for concern.

                V 1.0.2

             1) Fix bug:

        WASTEBOX.IFolder := m_pFolders[ORD(FOLDERS_OUTBOX)];
        WASTEBOX.DisplayName := 'WASTEBOX';

          change to

        WASTEBOX.IFolder := m_pFolders[ORD(FOLDERS_WASTE)];
        WASTEBOX.DisplayName := 'WASTEBOX';

        and change WASTEBOX to SENDBOX when SENDBOX folder opened.

             2) Add functions:

        function TMAPIMessage.GetBody: String;
        function TMAPIMessage.GetRTFBody: String;
        function TMAPIMessage.SetRead(Read: Boolean):Boolean;

        function TMAPIFolder.DeleteMessage(Index: Integer):Boolean;
        function TMAPIFolder.DeleteToWaste(Index: Integer):Boolean;


                      Thanks Roeland Moors for concern.


 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
unit VKMAPI;

interface

uses Windows, Messages, SysUtils, Classes, Dialogs, objidl, ComObj;

const

  IID_IMAPISession     : TGUID = '{00020300-0000-0000-C000-000000000046}';
  IID_IMAPITable       : TGUID = '{00020301-0000-0000-C000-000000000046}';
  IID_IMAPIAdviseSink  : TGUID = '{00020302-0000-0000-C000-000000000046}';
  IID_IMAPIControl     : TGUID = '{0002031B-0000-0000-C000-000000000046}';
  IID_IProfAdmin       : TGUID = '{0002031C-0000-0000-C000-000000000046}';
  IID_IMsgServiceAdmin : TGUID = '{0002031D-0000-0000-C000-000000000046}';
  IID_IProviderAdmin   : TGUID = '{00020325-0000-0000-C000-000000000046}';
  IID_IMAPIProgress    : TGUID = '{0002031F-0000-0000-C000-000000000046}';
  //* MAPIProp or derive from MAPIProp */
  IID_IMAPIProp        : TGUID = '{00020303-0000-0000-C000-000000000046}';
  IID_IProfSect        : TGUID = '{00020304-0000-0000-C000-000000000046}';
  IID_IMAPIStatus      : TGUID = '{00020305-0000-0000-C000-000000000046}';
  IID_IMsgStore        : TGUID = '{00020306-0000-0000-C000-000000000046}';
  IID_IMessage         : TGUID = '{00020307-0000-0000-C000-000000000046}';
  IID_IAttachment      : TGUID = '{00020308-0000-0000-C000-000000000046}';
  IID_IAddrBook        : TGUID = '{00020309-0000-0000-C000-000000000046}';
  IID_IMailUser        : TGUID = '{0002030A-0000-0000-C000-000000000046}';
  //* MAPIContainer or derive from MAPIContainer */
  IID_IMAPIContainer   : TGUID = '{0002030B-0000-0000-C000-000000000046}';
  IID_IMAPIFolder      : TGUID = '{0002030C-0000-0000-C000-000000000046}';
  IID_IABContainer     : TGUID = '{0002030D-0000-0000-C000-000000000046}';
  IID_IDistList        : TGUID = '{0002030E-0000-0000-C000-000000000046}';
  //* MAPI Support Object */
  IID_IMAPISup         : TGUID = '{0002030F-0000-0000-C000-000000000046}';
  //* Provider INIT objects */
  IID_IMSProvider      : TGUID = '{00020310-0000-0000-C000-000000000046}';
  IID_IABProvider      : TGUID = '{00020311-0000-0000-C000-000000000046}';
  IID_IXPProvider      : TGUID = '{00020312-0000-0000-C000-000000000046}';
  //* Provider LOGON Objects */
  IID_IMSLogon         : TGUID = '{00020313-0000-0000-C000-000000000046}';
  IID_IABLogon         : TGUID = '{00020314-0000-0000-C000-000000000046}';
  IID_IXPLogon         : TGUID = '{00020315-0000-0000-C000-000000000046}';
  //* IMAPITable-in-memory Table Data Object */
  IID_IMAPITableData   : TGUID = '{00020316-0000-0000-C000-000000000046}';
  //* MAPI Spooler Init Object (internal) */
  IID_IMAPISpoolerInit     : TGUID = '{00020317-0000-0000-C000-000000000046}';

  //* MAPI Spooler Session Object (internal) */
  IID_IMAPISpoolerSession  : TGUID = '{00020318-0000-0000-C000-000000000046}';

  //* MAPI TNEF Object Interface */
  IID_ITNEF            : TGUID = '{00020319-0000-0000-C000-000000000046}';
  //* IMAPIProp-in-memory Property Data Object */
  IID_IMAPIPropData    : TGUID = '{0002031A-0000-0000-C000-000000000046}';
  //* MAPI Spooler Hook Object */
  IID_ISpoolerHook     : TGUID = '{00020320-0000-0000-C000-000000000046}';
  //* MAPI Spooler Service Object */
  IID_IMAPISpoolerService  : TGUID = '{0002031E-0000-0000-C000-000000000046}';
  //* MAPI forms, form manager, etc. */
  IID_IMAPIViewContext     : TGUID = '{00020321-0000-0000-C000-000000000046}';
  IID_IMAPIFormMgr     : TGUID = '{00020322-0000-0000-C000-000000000046}';
  IID_IEnumMAPIFormProp    : TGUID = '{00020323-0000-0000-C000-000000000046}';
  IID_IMAPIFormInfo    : TGUID = '{00020324-0000-0000-C000-000000000046}';
  IID_IMAPIForm    : TGUID = '{00020327-0000-0000-C000-000000000046}';
  //* Well known guids for name<->id mappings */
  //*  The name of MAPI's property set  */
  PS_MAPI  : TGUID = '{00020328-0000-0000-C000-000000000046}';
  //*  The name of the set of public strings  */
  PS_PUBLIC_STRINGS    : TGUID = '{00020329-0000-0000-C000-000000000046}';
  //* MAPI forms, form manager, (cont) */
  IID_IPersistMessage  : TGUID = '{0002032A-0000-0000-C000-000000000046}';
  //* IMAPIViewAdviseSink */
  IID_IMAPIViewAdviseSink : TGUID = '{0002032B-0000-0000-C000-000000000046}';
  //* Message Store OpenProperty */
  IID_IStreamDocfile : TGUID = '{0002032C-0000-0000-C000-000000000046}';
  //* IMAPIFormProp */
  IID_IMAPIFormProp   : TGUID = '{0002032D-0000-0000-C000-000000000046}';
  //* IMAPIFormContainer */
  IID_IMAPIFormContainer : TGUID = '{0002032E-0000-0000-C000-000000000046}';
  //* IMAPIFormAdviseSink */
  IID_IMAPIFormAdviseSink : TGUID = '{0002032F-0000-0000-C000-000000000046}';
  //* TNEF OpenProperty */
  IID_IStreamTnef : TGUID = '{00020330-0000-0000-C000-000000000046}';
  //* IMAPIFormFactory */
  IID_IMAPIFormFactory : TGUID = '{00020350-0000-0000-C000-000000000046}';
  //* IMAPIMessageSite */
  IID_IMAPIMessageSite : TGUID = '{00020370-0000-0000-C000-000000000046}';
  //* Well known guids routing property sets.
  //   Usefull when writing applications that route documents
  //   (i.e. Workflow) across gateways.  Gateways that speak MAPI
  //   should convert the properties found in the follow property
  //   sets appropriately. */
  //*  PS_ROUTING_EMAIL_ADDRESSES:  Addresses that need converting at gateways, etc. */
  PS_ROUTING_EMAIL_ADDRESSES  : TGUID = '{00020380-0000-0000-C000-000000000046}';
  //*  PS_ROUTING_ADDRTYPE:  Address types that need converting at gateways, etc. */
  PS_ROUTING_ADDRTYPE : TGUID = '{00020381-0000-0000-C000-000000000046}';
  //*  PS_ROUTING_DISPLAY_NAME:  Display Name that corresponds to the other props */
  PS_ROUTING_DISPLAY_NAME : TGUID = '{00020382-0000-0000-C000-000000000046}';
  //*  PS_ROUTING_ENTRYID:  (optional) EntryIDs that need converting at gateways, etc. */
  PS_ROUTING_ENTRYID  : TGUID = '{00020383-0000-0000-C000-000000000046}';
  //*  PS_ROUTING_SEARCH_KEY:  (optional) search keys that need converting at gateways, etc. */
  PS_ROUTING_SEARCH_KEY   : TGUID = '{00020384-0000-0000-C000-000000000046}';
  ///*  MUID_PROFILE_INSTANCE
  //    Well known section in a profile which contains a property (PR_SEARCH_KEY) which is unique
  //    for any given profile.  Applications and providers can depend on this value as being
  //    different for each unique profile. */
  MUID_PROFILE_INSTANCE : TGUID = '{00020385-0000-0000-C000-000000000046}';

  MAX_SNDR                = 20;
  MAX_SUBJ                = 40;

  MAPI_DIM    = 1;

  MAPI_MODIFY             = $00000001;

  MAPI_INIT_VERSION               = 0;
  MAPI_MULTITHREAD_NOTIFICATIONS  = $00000001;

  MAPI_LOGOFF_SHARED      = $00000001;  //* Close all shared sessions    */
  MAPI_LOGOFF_UI          = $00000002;  //* It's OK to present UI        */

  {MAPILogon() flags.}
  MAPI_LOGON_UI           = $00000001;  //* Display logon UI                 */
  MAPI_NEW_SESSION        = $00000002;  //* Don't use shared session         */
  MAPI_ALLOW_OTHERS       = $00000008;  //* Make this a shared session       */
  MAPI_EXPLICIT_PROFILE   = $00000010;  //* Don't use default profile        */
  MAPI_EXTENDED           = $00000020;  //* Extended MAPI Logon              */
  MAPI_FORCE_DOWNLOAD     = $00001000;  //* Get new mail before return       */
  MAPI_SERVICE_UI_ALWAYS  = $00002000;  //* Do logon UI in all providers     */
  MAPI_NO_MAIL            = $00008000;  //* Do not activate transports       */
  MAPI_NT_SERVICE         = $00010000;  //* Allow logon from an NT service   */
  MAPI_PASSWORD_UI        = $00020000;  //* Display password UI only         */
  MAPI_TIMEOUT_SHORT      = $00100000;  //* Minimal wait for logon resources */

  MAPI_SIMPLE_DEFAULT     = (MAPI_LOGON_UI or MAPI_FORCE_DOWNLOAD or MAPI_ALLOW_OTHERS);
  MAPI_SIMPLE_EXPLICIT    = (MAPI_NEW_SESSION or MAPI_FORCE_DOWNLOAD or MAPI_EXPLICIT_PROFILE);

  //*  PR_STORE_SUPPORT_MASK bits */
  STORE_ENTRYID_UNIQUE    = $00000001;
  STORE_READONLY          = $00000002;
  STORE_SEARCH_OK         = $00000004;
  STORE_MODIFY_OK         = $00000008;
  STORE_CREATE_OK         = $00000010;
  STORE_ATTACH_OK         = $00000020;
  STORE_OLE_OK            = $00000040;
  STORE_SUBMIT_OK         = $00000080;
  STORE_NOTIFY_OK         = $00000100;
  STORE_MV_PROPS_OK       = $00000200;
  STORE_CATEGORIZE_OK     = $00000400;
  STORE_RTF_OK            = $00000800;
  STORE_RESTRICTION_OK    = $00001000;
  STORE_SORT_OK           = $00002000;
  STORE_PUBLIC_FOLDERS    = $00004000;
  STORE_UNCOMPRESSED_RTF  = $00008000;

  //* PR_STORE_STATE bits, try not to collide with PR_STORE_SUPPORT_MASK */

  STORE_HAS_SEARCHES      = $01000000;


  PROP_TYPE_MASK          = $0000FFFF; //* Mask for Property type */
  PROP_ID_NULL            = 0;
  PROP_ID_INVALID         = $FFFF;

  //* OpenEntry() */

  //****** MAPI_MODIFY             ((ULONG) 0x00000001) above */
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  //****** MAPI_BEST_ACCESS        ((ULONG) 0x00000010) above */

  //* SetReceiveFolder() */

  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* GetReceiveFolder() */

  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* GetReceiveFolderTable() */

  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */

  //* StoreLogoff() */

  LOGOFF_NO_WAIT          = $00000001;
  LOGOFF_ORDERLY          = $00000002;
  LOGOFF_PURGE            = $00000004;
  LOGOFF_ABORT            = $00000008;
  LOGOFF_QUIET            = $00000010;

  LOGOFF_COMPLETE         = $00010000;
  LOGOFF_INBOUND          = $00020000;
  LOGOFF_OUTBOUND         = $00040000;
  LOGOFF_OUTBOUND_QUEUE   = $00080000;

  //* SetLockState() */

  MSG_LOCKED              = $00000001;
  MSG_UNLOCKED            = $00000000;

  //* Flag bits for PR_VALID_FOLDER_MASK */

  FOLDER_IPM_SUBTREE_VALID        = $00000001;
  FOLDER_IPM_INBOX_VALID          = $00000002;
  FOLDER_IPM_OUTBOX_VALID         = $00000004;
  FOLDER_IPM_WASTEBASKET_VALID    = $00000008;
  FOLDER_IPM_SENTMAIL_VALID       = $00000010;
  FOLDER_VIEWS_VALID              = $00000020;
  FOLDER_COMMON_VIEWS_VALID       = $00000040;
  FOLDER_FINDER_VALID             = $00000080;

  //* Flags for OpenAddressBook */

  AB_NO_DIALOG            = $00000001;

  {/* Table status */}

  TBLSTAT_COMPLETE            = 0;
  TBLSTAT_QCHANGED            = 7;
  TBLSTAT_SORTING             = 9;
  TBLSTAT_SORT_ERROR          = 10;
  TBLSTAT_SETTING_COLS        = 11;
  TBLSTAT_SETCOL_ERROR        = 13;
  TBLSTAT_RESTRICTING         = 14;
  TBLSTAT_RESTRICT_ERROR      = 15;

  {/* Table Type */}

  TBLTYPE_SNAPSHOT            = 0;
  TBLTYPE_KEYSET              = 1;
  TBLTYPE_DYNAMIC             = 2;

  {/* Sort order */}

  {/* bit 0: set if descending, clear if ascending */}

  TABLE_SORT_ASCEND       = $00000000;
  TABLE_SORT_DESCEND      = $00000001;
  TABLE_SORT_COMBINE      = $00000002;

  BOOKMARK_BEGINNING  = 0;      //* Before first row */
  BOOKMARK_CURRENT    = 01;      //* Before current row */
  BOOKMARK_END        = 02;      //* After last row */

  {/* Fuzzy Level */}

  FL_FULLSTRING       = $00000000;
  FL_SUBSTRING        = $00000001;
  FL_PREFIX           = $00000002;

  FL_IGNORECASE       = $00010000;
  FL_IGNORENONSPACE   = $00020000;
  FL_LOOSE            = $00040000;

  //* Restriction types */

  RES_AND             = $00000000;
  RES_OR              = $00000001;
  RES_NOT             = $00000002;
  RES_CONTENT         = $00000003;
  RES_PROPERTY        = $00000004;
  RES_COMPAREPROPS    = $00000005;
  RES_BITMASK         = $00000006;
  RES_SIZE            = $00000007;
  RES_EXIST           = $00000008;
  RES_SUBRESTRICTION  = $00000009;
  RES_COMMENT         = $0000000A;

  //* Relational operators. These apply to all property comparison restrictions. */

  RELOP_LT        = 0;     //* <  */
  RELOP_LE        = 1;     //* <= */
  RELOP_GT        = 2;     //* >  */
  RELOP_GE        = 3;     //* >= */
  RELOP_EQ        = 4;     //* == */
  RELOP_NE        = 5;     //* != */
  RELOP_RE        = 6;     //* LIKE (Regular expression) */

  //* Bitmask operators, for RES_BITMASK only. */

  BMR_EQZ     = 0;     //* ==0 */
  BMR_NEZ     = 1;     //* !=0 */

  //* Subobject identifiers for RES_SUBRESTRICTION only. See MAPITAGS.H. */

  //* #define PR_MESSAGE_RECIPIENTS  PROP_TAG(PT_OBJECT,0x0E12) */
  //* #define PR_MESSAGE_ATTACHMENTS PROP_TAG(PT_OBJECT,0x0E13) */

  //* Property Types */

  MV_FLAG         = $1000;          //* Multi-value flag */

  PT_UNSPECIFIED  = 0;    //* (Reserved for interface use) type doesn't matter to caller */
  PT_NULL         = 1;    //* NULL property value */
  PT_I2           = 2;    //* Signed 16-bit value */
  PT_LONG         = 3;    //* Signed 32-bit value */
  PT_R4           = 4;    //* 4-byte floating point */
  PT_DOUBLE       = 5;    //* Floating point double */
  PT_CURRENCY     = 6;    //* Signed 64-bit int (decimal w/    4 digits right of decimal pt) */
  PT_APPTIME      = 7;    //* Application time */
  PT_ERROR        = 10;    //* 32-bit error value */
  PT_BOOLEAN      = 11;    //* 16-bit boolean (non-zero true) */
  PT_OBJECT       = 13;    //* Embedded object in a property */
  PT_I8           = 20;    //* 8-byte signed integer */
  PT_STRING8      = 30;    //* Null terminated 8-bit character string */
  PT_UNICODE      = 31;    //* Null terminated Unicode string */
  PT_SYSTIME      = 64;    //* FILETIME 64-bit int w/ number of 100ns periods since Jan 1,1601 */
  PT_CLSID        = 72;    //* OLE GUID */
  PT_BINARY       = 258;   //* Uninterpreted (counted byte array) */
  //* Changes are likely to these numbers, and to their structures. */

  //* Alternate property type names for ease of use */
  PT_SHORT    =PT_I2;
  PT_I4       =PT_LONG;
  PT_FLOAT    =PT_R4;
  PT_R8       =PT_DOUBLE;
  PT_LONGLONG =PT_I8;

  PT_TSTRING          =PT_STRING8;
  PT_MV_TSTRING       =(MV_FLAG or PT_STRING8);

  //* Multi-valued Property Types */

  PT_MV_I2        = (MV_FLAG or PT_I2);
  PT_MV_LONG      = (MV_FLAG or PT_LONG);
  PT_MV_R4        = (MV_FLAG or PT_R4);
  PT_MV_DOUBLE    = (MV_FLAG or PT_DOUBLE);
  PT_MV_CURRENCY  = (MV_FLAG or PT_CURRENCY);
  PT_MV_APPTIME   = (MV_FLAG or PT_APPTIME);
  PT_MV_SYSTIME   = (MV_FLAG or PT_SYSTIME);
  PT_MV_STRING8   = (MV_FLAG or PT_STRING8);
  PT_MV_BINARY    = (MV_FLAG or PT_BINARY);
  PT_MV_UNICODE   = (MV_FLAG or PT_UNICODE);
  PT_MV_CLSID     = (MV_FLAG or PT_CLSID);
  PT_MV_I8        = (MV_FLAG or PT_I8);

  //* Alternate property type names for ease of use */
  PT_MV_SHORT     = PT_MV_I2;
  PT_MV_I4        = PT_MV_LONG;
  PT_MV_FLOAT     = PT_MV_R4;
  PT_MV_R8        = PT_MV_DOUBLE;
  PT_MV_LONGLONG  = PT_MV_I8;

  //
  // *  Property type reserved bits
  // *
  // *  MV_INSTANCE is used as a flag in table operations to request
  // *  that a multi-valued property be presented as a single-valued
  // *  property appearing in multiple rows.
  // */

  MV_INSTANCE     = $2000;
  MVI_FLAG        = (MV_FLAG or MV_INSTANCE);
  //MVI_PROP(tag)   ((tag) | MVI_FLAG)

  fnevCriticalError           = $00000001;
  fnevNewMail                 = $00000002;
  fnevObjectCreated           = $00000004;
  fnevObjectDeleted           = $00000008;
  fnevObjectModified          = $00000010;
  fnevObjectMoved             = $00000020;
  fnevObjectCopied            = $00000040;
  fnevSearchComplete          = $00000080;
  fnevTableModified           = $00000100;
  fnevStatusObjectModified    = $00000200;
  fnevReservedForMapi         = $40000000;
  fnevExtended                = $80000000;

  //* TABLE_NOTIFICATION event types passed in ulTableEvent */

  TABLE_CHANGED       = 1;
  TABLE_ERROR         = 2;
  TABLE_ROW_ADDED     = 3;
  TABLE_ROW_DELETED   = 4;
  TABLE_ROW_MODIFIED  = 5;
  TABLE_SORT_DONE     = 6;
  TABLE_RESTRICT_DONE = 7;
  TABLE_SETCOL_DONE   = 8;
  TABLE_RELOAD        = 9;

  //* IMAPIFolder folder type (enum) */

  FOLDER_ROOT             = $00000000;
  FOLDER_GENERIC          = $00000001;
  FOLDER_SEARCH           = $00000002;

  //* CreateMessage */
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  //****** MAPI_ASSOCIATED         ((ULONG) 0x00000040) below */

  //* CopyMessages */

  MESSAGE_MOVE            = $00000001;
  MESSAGE_DIALOG          = $00000002;
  //****** MAPI_DECLINE_OK         ((ULONG) 0x00000004) above */

  //* CreateFolder */

  OPEN_IF_EXISTS          = $00000001;
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* DeleteFolder */

  DEL_MESSAGES            = $00000001;
  FOLDER_DIALOG           = $00000002;
  DEL_FOLDERS             = $00000004;

  //* EmptyFolder */
  DEL_ASSOCIATED          = $00000008;

  //* CopyFolder */

  FOLDER_MOVE             = $00000001;
  //****** FOLDER_DIALOG           ((ULONG) 0x00000002) above */
  //****** MAPI_DECLINE_OK         ((ULONG) 0x00000004) above */
  COPY_SUBFOLDERS         =00000010;
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */


  //* SetReadFlags */

  //****** SUPPRESS_RECEIPT        ((ULONG) 0x00000001) below */
  //****** FOLDER_DIALOG           ((ULONG) 0x00000002) above */
  //****** CLEAR_READ_FLAG         ((ULONG) 0x00000004) below */
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  //****** GENERATE_RECEIPT_ONLY   ((ULONG) 0x00000010) below */
  //****** CLEAR_RN_PENDING        ((ULONG) 0x00000020) below */
  //****** CLEAR_NRN_PENDING       ((ULONG) 0x00000040) below */


  //* GetMessageStatus */

  MSGSTATUS_HIGHLIGHTED   = $00000001;
  MSGSTATUS_TAGGED        = $00000002;
  MSGSTATUS_HIDDEN        = $00000004;
  MSGSTATUS_DELMARKED     = $00000008;

  //* Bits for remote message status */

  MSGSTATUS_REMOTE_DOWNLOAD   = $00001000;
  MSGSTATUS_REMOTE_DELETE     = $00002000;

  //* SaveContentsSort */

  RECURSIVE_SORT          = $00000002;

  //* PR_STATUS property */

  FLDSTATUS_HIGHLIGHTED   = $00000001;
  FLDSTATUS_TAGGED        = $00000002;
  FLDSTATUS_HIDDEN        = $00000004;
  FLDSTATUS_DELMARKED     = $00000008;

  //* SubmitMessage */

  FORCE_SUBMIT                = $00000001;

  //* Flags defined in PR_MESSAGE_FLAGS */

  MSGFLAG_READ            = $00000001;
  MSGFLAG_UNMODIFIED      = $00000002;
  MSGFLAG_SUBMIT          = $00000004;
  MSGFLAG_UNSENT          = $00000008;
  MSGFLAG_HASATTACH       = $00000010;
  MSGFLAG_FROMME          = $00000020;
  MSGFLAG_ASSOCIATED      = $00000040;
  MSGFLAG_RESEND          = $00000080;
  MSGFLAG_RN_PENDING      = $00000100;
  MSGFLAG_NRN_PENDING     = $00000200;

  //* Flags defined in PR_SUBMIT_FLAGS */

  SUBMITFLAG_LOCKED       = $00000001;
  SUBMITFLAG_PREPROCESS   = $00000002;

  //* GetAttachmentTable() */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* GetRecipientTable() */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* ModifyRecipients */

  //* ((ULONG) 0x00000001 is not a valid flag on ModifyRecipients. */
  MODRECIP_ADD            = $00000002;
  MODRECIP_MODIFY         = $00000004;
  MODRECIP_REMOVE         = $00000008;

  //* SetReadFlag */

  SUPPRESS_RECEIPT        = $00000001;
  CLEAR_READ_FLAG         = $00000004;
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  GENERATE_RECEIPT_ONLY   = $00000010;
  CLEAR_RN_PENDING        = $00000020;
  CLEAR_NRN_PENDING       = $00000040;

  //* DeleteAttach */

  ATTACH_DIALOG           = $00000001;

  //* PR_SECURITY values */
  SECURITY_SIGNED         = $00000001;
  SECURITY_ENCRYPTED      = $00000002;

  //* PR_PRIORITY values */
  PRIO_URGENT             =1;
  PRIO_NORMAL             =0;
  PRIO_NONURGENT          =-1;

  //* PR_SENSITIVITY values */
  SENSITIVITY_NONE                    = $00000000;
  SENSITIVITY_PERSONAL                = $00000001;
  SENSITIVITY_PRIVATE                 = $00000002;
  SENSITIVITY_COMPANY_CONFIDENTIAL    = $00000003;

  //* PR_IMPORTANCE values */
  IMPORTANCE_LOW          =0;
  IMPORTANCE_NORMAL       =1;
  IMPORTANCE_HIGH         =2;

  //* GetLastError */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //*
  // *  Version:
  // */
  MAPI_ERROR_VERSION      = $00000000;

  //* GetPropList */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* GetProps */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* SaveChanges */

  KEEP_OPEN_READONLY      = $00000001;
  KEEP_OPEN_READWRITE     = $00000002;
  FORCE_SAVE              = $00000004;
  //* define MAPI_DEFERRED_ERRORS  ((ULONG) 0x00000008) below */

  //* OpenProperty  - ulFlags */
  //****** MAPI_MODIFY             ((ULONG) 0x00000001) above */
  MAPI_CREATE             = $00000002;
  STREAM_APPEND           = $00000004;
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */

  //* OpenProperty  - ulInterfaceOptions, IID_IMAPITable */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* CopyTo, CopyProps */

  MAPI_MOVE               = $00000001;
  MAPI_NOREPLACE          = $00000002;
  MAPI_DECLINE_OK         = $00000004;

  MAPI_DIALOG             = $00000008;

  MAPI_USE_DEFAULT        = $00000040;  //* Use default profile in logon */


  //* Flags used in GetIDsFromNames  */
  //****** MAPI_CREATE             ((ULONG) 0x00000002) above */

  //* Flags used in GetNamesFromIDs  (bit fields) */
  MAPI_NO_STRINGS         = $00000001;
  MAPI_NO_IDS             = $00000002;

  //*  Union discriminator  */
  MNID_ID                 =0;
  MNID_STRING             =1;

  //* --------------------------------- */
  //* Address Book interface definition */

  //* ADRPARM ulFlags - top 4 bits used for versioning */

  //GET_ADRPARM_VERSION(ulFlags)  (((ULONG)ulFlags) & 0xF0000000)
  //SET_ADRPARM_VERSION(ulFlags, ulVersion)  (((ULONG)ulVersion) | (((ULONG)ulFlags) & 0x0FFFFFFF))

  //*  Current versions of ADRPARM  */
  ADRPARM_HELP_CTX        = $00000000;


  //*  ulFlags   - bit fields */
  DIALOG_MODAL            = $000000001;
  DIALOG_SDI              = $000000002;
  DIALOG_OPTIONS          = $000000004;
  ADDRESS_ONE             = $000000008;
  AB_SELECTONLY           = $000000010;
  AB_RESOLVE              = $000000020;

  //* --------------------------------- */
  //*  PR_DISPLAY_TYPEs                 */
  //*
  // *  These standard display types are
  // *  by default handled by MAPI.
  // *  They have default icons associated
  // *  with them.
  // */

  //*  For address book contents tables */
  DT_MAILUSER         = $000000000;
  DT_DISTLIST         = $000000001;
  DT_FORUM            = $000000002;
  DT_AGENT            = $000000003;
  DT_ORGANIZATION     = $000000004;
  DT_PRIVATE_DISTLIST = $000000005;
  DT_REMOTE_MAILUSER  = $000000006;

  //*  For address book hierarchy tables */
  DT_MODIFIABLE       = $000010000;
  DT_GLOBAL           = $000020000;
  DT_LOCAL            = $000030000;
  DT_WAN              = $000040000;
  DT_NOT_SPECIFIC     = $000050000;

  //*  For folder hierarchy tables */
  DT_FOLDER           = $001000000;
  DT_FOLDER_LINK      = $002000000;
  DT_FOLDER_SPECIAL   = $004000000;


  ///* ------------ */
  ///* Random flags */

  //* Flag for deferred error */
  MAPI_DEFERRED_ERRORS    = $00000008;

  //* Flag for creating and using Folder Associated Information Messages */
  MAPI_ASSOCIATED         = $00000040;

  //* Flags for OpenMessageStore() */

  MDB_NO_DIALOG           = $00000001;
  MDB_WRITE               = $00000004;
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) above */
  //****** MAPI_BEST_ACCESS        ((ULONG) 0x00000010) above */
  MDB_TEMPORARY           = $00000020;
  MDB_NO_MAIL             = $00000080;

  //* Flags for OpenAddressBook */

  //* IMAPIControl Interface -------------------------------------------------- */

  //* Interface used in controls (particularly the button) defined by */
  //* Display Tables. */

  //*  Flags for GetState */

  MAPI_ENABLED       = $00000000;
  MAPI_DISABLED      = $00000001;

  //* Object type */

  MAPI_STORE      = $00000001;    //* Message Store */
  MAPI_ADDRBOOK   = $00000002;    //* Address Book */
  MAPI_FOLDER     = $00000003;    //* Folder */
  MAPI_ABCONT     = $00000004;    //* Address Book Container */
  MAPI_MESSAGE    = $00000005;    //* Message */
  MAPI_MAILUSER   = $00000006;    //* Individual Recipient */
  MAPI_ATTACH     = $00000007;    //* Attachment */
  MAPI_DISTLIST   = $00000008;    //* Distribution List Recipient */
  MAPI_PROFSECT   = $00000009;    //* Profile Section */
  MAPI_STATUS     = $0000000A;    //* Status Object */
  MAPI_SESSION    = $0000000B;    //* Session */
  MAPI_FORMINFO   = $0000000C;    //* Form Information */

  SUCCESS_SUCCESS                 =0;
  MAPI_USER_ABORT                 =1;
  MAPI_E_USER_ABORT               =MAPI_USER_ABORT;
  MAPI_E_FAILURE                  =2;
  MAPI_E_LOGON_FAILURE            =3;
  MAPI_E_LOGIN_FAILURE            =MAPI_E_LOGON_FAILURE;
  MAPI_E_DISK_FULL                =4;
  MAPI_E_INSUFFICIENT_MEMORY      =5;
  MAPI_E_ACCESS_DENIED            =6;
  MAPI_E_TOO_MANY_SESSIONS        =8;
  MAPI_E_TOO_MANY_FILES           =9;
  MAPI_E_TOO_MANY_RECIPIENTS      =10;
  MAPI_E_ATTACHMENT_NOT_FOUND     =11;
  MAPI_E_ATTACHMENT_OPEN_FAILURE  =12;
  MAPI_E_ATTACHMENT_WRITE_FAILURE =13;
  MAPI_E_UNKNOWN_RECIPIENT        =14;
  MAPI_E_BAD_RECIPTYPE            =15;
  MAPI_E_NO_MESSAGES              =16;
  MAPI_E_INVALID_MESSAGE          =17;
  MAPI_E_TEXT_TOO_LARGE           =18;
  MAPI_E_INVALID_SESSION          =19;
  MAPI_E_TYPE_NOT_SUPPORTED       =20;
  MAPI_E_AMBIGUOUS_RECIPIENT      =21;
  MAPI_E_AMBIG_RECIP              =MAPI_E_AMBIGUOUS_RECIPIENT;
  MAPI_E_MESSAGE_IN_USE           =22;
  MAPI_E_NETWORK_FAILURE          =23;
  MAPI_E_INVALID_EDITFIELDS       =24;
  MAPI_E_INVALID_RECIPS           =25;
  MAPI_E_NOT_SUPPORTED            =26;

  //* Values for PR_RESOURCE_TYPE, _METHODS, _FLAGS */

  MAPI_STORE_PROVIDER     = 33;    //* Message Store */
  MAPI_AB                 = 34;    //* Address Book */
  MAPI_AB_PROVIDER        = 35;    //* Address Book Provider */
  MAPI_TRANSPORT_PROVIDER = 36;    //* Transport Provider */
  MAPI_SPOOLER            = 37;    //* Message Spooler */
  MAPI_PROFILE_PROVIDER   = 38;    //* Profile Provider */
  MAPI_SUBSYSTEM          = 39;    //* Overall Subsystem Status */
  MAPI_HOOK_PROVIDER      = 40;    //* Spooler Hook */

  STATUS_VALIDATE_STATE   = $00000001;
  STATUS_SETTINGS_DIALOG  = $00000002;
  STATUS_CHANGE_PASSWORD  = $00000004;
  STATUS_FLUSH_QUEUES     = $00000008;

  STATUS_DEFAULT_OUTBOUND = $00000001;
  STATUS_DEFAULT_STORE    = $00000002;
  STATUS_PRIMARY_IDENTITY = $00000004;
  STATUS_SIMPLE_STORE     = $00000008;
  STATUS_XP_PREFER_LAST   = $00000010;
  STATUS_NO_PRIMARY_IDENTITY = $00000020;
  STATUS_NO_DEFAULT_STORE = $00000040;
  STATUS_TEMP_SECTION     = $00000080;
  STATUS_OWN_STORE        = $00000100;
  //****** HOOK_INBOUND            ((ULONG) 0x00000200) Defined in MAPIHOOK.H */
  //****** HOOK_OUTBOUND           ((ULONG) 0x00000400) Defined in MAPIHOOK.H */
  STATUS_NEED_IPM_TREE    = $00000800;
  STATUS_PRIMARY_STORE    = $00001000;
  STATUS_SECONDARY_STORE  = $00002000;

  //*
  // * PR_STATUS_CODE bit. Low 16 bits for common values; High 16 bits
  // * for provider type-specific values. (DCR 304)
  // */

  STATUS_AVAILABLE        = $00000001;
  STATUS_OFFLINE          = $00000002;
  STATUS_FAILURE          = $00000004;

  //* Transport values of PR_STATUS_CODE */

  STATUS_INBOUND_ENABLED  = $00010000;
  STATUS_INBOUND_ACTIVE   = $00020000;
  STATUS_INBOUND_FLUSH    = $00040000;
  STATUS_OUTBOUND_ENABLED = $00100000;
  STATUS_OUTBOUND_ACTIVE  = $00200000;
  STATUS_OUTBOUND_FLUSH   = $00400000;
  STATUS_REMOTE_ACCESS    = $00800000;

  //* ValidateState flags */

  SUPPRESS_UI                 = $00000001;
  REFRESH_XP_HEADER_CACHE     = $00010000;
  PROCESS_XP_HEADER_CACHE     = $00020000;
  FORCE_XP_CONNECT            = $00040000;
  FORCE_XP_DISCONNECT         = $00080000;
  CONFIG_CHANGED              = $00100000;
  ABORT_XP_HEADER_OPERATION   = $00200000;
  SHOW_XP_SESSION_UI          = $00400000;

  //* SettingsDialog flags */

  UI_READONLY     = $00000001;

  //* FlushQueues flags */

  FLUSH_UPLOAD        = $00000002;
  FLUSH_DOWNLOAD      = $00000004;
  FLUSH_FORCE         = $00000008;
  FLUSH_NO_UI         = $00000010;
  FLUSH_ASYNC_OK      = $00000020;

  //* Flags for OpenEntry() */

  //****** MAPI_MODIFY             ((ULONG) 0x00000001) above */
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  MAPI_BEST_ACCESS        = $00000010;

  //* GetContentsTable() */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */
  //****** MAPI_ASSOCIATED         ((ULONG) 0x00000040) below */

  //* GetHierarchyTable() */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */
  CONVENIENT_DEPTH        = $00000001;
  //****** MAPI_DEFERRED_ERRORS    ((ULONG) 0x00000008) below */

  //* GetSearchCriteria */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */
  SEARCH_RUNNING          = $00000001;
  SEARCH_REBUILD          = $00000002;
  SEARCH_RECURSIVE        = $00000004;
  SEARCH_FOREGROUND       = $00000008;

  //* SetSearchCriteria */
  STOP_SEARCH             = $00000001;
  RESTART_SEARCH          = $00000002;
  RECURSIVE_SEARCH        = $00000004;
  SHALLOW_SEARCH          = $00000008;
  FOREGROUND_SEARCH       = $00000010;
  BACKGROUND_SEARCH       = $00000020;

  FLUSH_FLAGS              = FLUSH_UPLOAD or FLUSH_DOWNLOAD or FLUSH_FORCE;

  //* Values for PR_RESOURCE_FLAGS in message service table */

  SERVICE_DEFAULT_STORE       = $00000001;
  SERVICE_SINGLE_COPY         = $00000002;
  SERVICE_CREATE_WITH_STORE   = $00000004;
  SERVICE_PRIMARY_IDENTITY    = $00000008;
  SERVICE_NO_PRIMARY_IDENTITY = $00000020;

  //*  GetMsgServiceTable */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) */

  //*  GetProviderTable */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) */

  //* Flags for ConfigureMsgService */

  UI_SERVICE                  = $00000002;
  SERVICE_UI_ALWAYS           = $00000002;      //* Duplicate UI_SERVICE for consistency and compatibility */
  SERVICE_UI_ALLOWED          = $00000010;
  UI_CURRENT_PROVIDER_FIRST   = $00000004;
  //* MSG_SERVICE_UI_READ_ONLY         0x00000008 - in MAPISPI.H */

  //* GetProviderTable() */
  //****** MAPI_UNICODE            ((ULONG) 0x80000000) above */

  //* Values for PR_RESOURCE_FLAGS in message service table */


  //* IAttach attachment methods: PR_ATTACH_METHOD values */

  NO_ATTACHMENT           = $00000000;
  ATTACH_BY_VALUE         = $00000001;
  ATTACH_BY_REFERENCE     = $00000002;
  ATTACH_BY_REF_RESOLVE   = $00000003;
  ATTACH_BY_REF_ONLY      = $00000004;
  ATTACH_EMBEDDED_MSG     = $00000005;
  ATTACH_OLE              = $00000006;

  //* Recipient types */
  MAPI_ORIG   =0;           //* Recipient is message originator          */
  MAPI_TO     =1;           //* Recipient is a primary recipient         */
  MAPI_CC     =2;           //* Recipient is a copy recipient            */
  MAPI_BCC    =3;           //* Recipient is blind copy recipient        */
  MAPI_P1     =$10000000;  //* Recipient is a P1 resend recipient       */
  MAPI_SUBMITTED =$80000000; //* Recipient is already processed         */
  //* #define MAPI_AUTHORIZE 4        recipient is a CMC authorizing user      */
  //*#define MAPI_DISCRETE 0x10000000 Recipient is a P1 resend recipient       */

type

  {forward declarations}

  IMAPIAdviseSink = interface;
  LPMAPIADVISESINK = ^IMAPIAdviseSink;
  LPPMAPIADVISESINK = ^LPMAPIADVISESINK;
  IMAPITable = interface;
  LPMAPITABLE = ^IMAPITable;
  LPPMAPITABLE = ^LPMAPITABLE;
  IMsgStore = interface;
  LPMDB = ^IMsgStore;
  LPPMDB = LPMDB;
  IAddrBook = interface;
  LPADRBOOK = ^IAddrBook;
  LPPADRBOOK = ^LPADRBOOK;
  IProfSect = interface;
  LPPROFSECT = ^IProfSect;
  LPPPROFSECT = ^LPPROFSECT;
  IMAPIMessage = interface;
  LPMESSAGE = ^IMAPIMessage;
  LPPMESSAGE = ^LPMESSAGE;
  IMsgServiceAdmin = interface;
  LPSERVICEADMIN = ^IMsgServiceAdmin;
  LPPSERVICEADMIN = ^LPSERVICEADMIN;
  IMAPIFolder = interface;
  LPMAPIFOLDER = ^IMAPIFolder;
  LPPMAPIFOLDER =^LPMAPIFOLDER;
  IMAPISession = interface;
  LPMAPISESSION = ^IMAPISession;
  LPPMAPISESSION = ^LPMAPISESSION;
  IMAPIProgress = interface;
  LPMAPIPROGRESS = ^IMAPIProgress;
  LPPMAPIPROGRESS = ^LPMAPIPROGRESS;
  IAttach = interface;
  LPATTACH = ^IAttach;
  LPPATTACH = ^LPATTACH;
  IMAPIProp = interface;
  LPMAPIPROP = ^IMAPIProp;
  LPPMAPIPROP = ^LPMAPIPROP;
  IMAPIStatus = interface;
  LPMAPISTATUS = ^IMAPIStatus;
  LPPMAPISTATUS = ^LPMAPISTATUS;
  IMAPIContainer = interface;
  LPMAPICONTAINER = ^IMAPIContainer;
  LPPMAPICONTAINER = ^LPMAPICONTAINER;
  IProviderAdmin = interface;
  LPPROVIDERADMIN = ^IProviderAdmin;
  LPPPROVIDERADMIN = ^LPPROVIDERADMIN;

  _MSG_PROPS_ = (MSG_SUBJ, MSG_BODY, MSG_FLAG, MSG_SNDR, MSG_ATT, NUM_MSG_PROPS);
  _RECIPS_    = (RECIPS_NAME, RECIPS_EID, RECIPS_ADDR, RECIPS_RECIP, RECIPS_EMAIL, RECIPS_SKEY, RECIPS_NUM_RECIP_PROPS);
  _CTX_ID_    = (CTX_INIT, CTX_INBOX, CTX_COMPOSE, CTX_READNOTE, CTX_SAVED, CTX_REPLY, CTX_REPLY_ALL, CTX_FORWARD);
  _FOLDERS_   = (FOLDERS_INBOX, FOLDERS_OUTBOX, FOLDERS_WASTE, FOLDERS_SENT, FOLDERS_IPM_ROOT, FOLDERS_NUM_FOLDERS);
  _WHO_TO_    = (WHO_TO_SENDER, WHO_TO_ALL);
  _OB_PROPS_  = (OBSUBJ, OBBODY, OBFLAG, OBSENT, NUM_OUTBOUND_PROPS);
  FOLDERS_TYPE = (ftInbox, ftOutbox, ftWastebox, ftSentbox);

  {shared with simple mapi}

  FLAGS = ULONG;

  {Extended MAPI Error Information -----------------------------------------}

  MAPIERROR = packed record
    ulVersion: ULONG;
    lpszError: pChar;
    lpszComponent: pChar;
    ulLowLevelError: ULONG;
    ulContext: ULONG;
  end;
  LPMAPIERROR = ^MAPIERROR;
  LPPMAPIERROR = ^LPMAPIERROR;

  {/* Data structures */}

  SSortOrder = packed record
    ulPropTag: ULONG;          //* Column to sort on */
    ulOrder: ULONG;            //* Ascending, descending, combine to left */
  end;
  LPSSortOrder = ^SSortOrder;

  SSortOrderSet = packed record
    cSorts: ULONG;     //* Number of sort columns in aSort below*/
    cCategories: ULONG;   //* 0 for non-categorized, up to cSorts */
    cExpanded: ULONG;      //* 0 if no categories start expanded, */
                                    //*      up to cExpanded */
    aSort: array [0..MAPI_DIM-1] of SSortOrder;    //* The sort orders */
  end;
  LPSSortOrderSet = ^SSortOrderSet;
  LPPSSortOrderSet = ^LPSSortOrderSet;

  BOOKMARK = ULONG;
  PBOOKMARK = ^BOOKMARK;

  //* ENTRYID */
  ENTRYID = packed record
    abFlags: array[0..3] of BYTE;
    ab: array [0..MAPI_DIM-1] of BYTE;
  end;
  LPENTRYID = ^ENTRYID;
  LPPENTRYID = ^LPENTRYID;

  //* Byte-order-independent version of GUID (world-unique identifier) */
  MAPIUID = packed record
    ab: array[0..15] of BYTE;
  end;
  LPMAPIUID = ^MAPIUID;

  //* Property Tag Array */

  SPropTagArray = packed record
    cValues: ULONG;
    aulPropTag: array[0..MAPI_DIM-1] of ULONG;
  end;
  LPSPropTagArray = ^SPropTagArray;
  LPPSPropTagArray = ^LPSPropTagArray;

  CY = packed record
    case Byte of
      0: (Lo: ULONG; Hi: LONG;);
      1: (int64: LONGLONG);
  end;
  CURRENCY = CY;
  PCURRENCY = ^CURRENCY;

  SBinary = packed record
    cb: ULONG;
    lpb: LPBYTE;
  end;
  LPSBinary = ^SBinary;

  SShortArray = packed record
    cValues: ULONG;
    lpi: LPSMALLINT;
  end;

  SGuidArray = packed record
    cValues: ULONG;
    lpguid: PGUID;
  end;

  SRealArray = packed record
    cValues: ULONG;
    lpflt: LPSINGLE;
  end;

  SLongArray = packed record
    cValues: ULONG;
    lpl: PLONG;
  end;

  LARGE_INTEGER = packed record
    case Byte of
      0: (LowPart: DWORD; HighPart: LONG);
      1: (QuadPart: LONGLONG);
  end;
  PLARGE_INTEGER = ^LARGE_INTEGER;

  SLargeIntegerArray = packed record
    cValues: ULONG;
    lpli: PLARGE_INTEGER;
  end;

  FILETIME = packed record
    dwLowDateTime: DWORD;
    dwHighDateTime: DWORD;
  end;
  LPFILETIME = ^FILETIME;

  SDateTimeArray = packed record
    cValues: ULONG;
    lpft: LPFILETIME;
  end;

  SAppTimeArray = packed record
    cValues: ULONG;
    lpat: LPDOUBLE;
  end;

  SCurrencyArray = packed record
    cValues: ULONG;
    lpcur: PCURRENCY;
  end;

  SBinaryArray = packed record
    cValues: ULONG;
    lpbin: LPSBinary;
  end;
  ENTRYLIST = SBinaryArray;
  LPENTRYLIST = ^ENTRYLIST;
  LPPENTRYLIST = ^LPENTRYLIST;

  SDoubleArray = packed record
    cValues: ULONG;
    lpdbl: LPDOUBLE;
  end;

  SWStringArray = packed record
    cValues: ULONG;
    lppszW: PWideChar;
  end;

  SLPSTRArray = packed record
    cValues: ULONG;
    lppszA: PChar;
  end;

  _PV = packed record
    case ULONG of
      PT_I2         : (i: SmallInt;             ); //* case PT_I2            */
      PT_LONG       : (l: LONG;                 ); //* case PT_LONG          */
      100000        : (ul: ULONG;               ); //* case PT_LONG          */
      PT_R4         : (flt: Single;             ); //* case PT_R4            */
      PT_DOUBLE     : (dbl: double;             ); //* case PT_DOUBLE        */
      PT_BOOLEAN    : (b: word;                 ); //* case PT_BOOLEAN       */
      PT_CURRENCY   : (cur: CURRENCY;           ); //* case PT_CURRENCY      */
      PT_APPTIME    : (at: double;              ); //* case PT_APPTIME       */
      PT_SYSTIME    : (ft: FILETIME;            ); //* case PT_SYSTIME       */
      PT_STRING8    : (lpszA: LPSTR;            ); //* case PT_STRING8       */
      PT_BINARY     : (bin: SBinary;            ); //* case PT_BINARY        */
      PT_UNICODE    : (lpszW: pWideChar;        ); //* case PT_UNICODE       */
      PT_CLSID      : (lpguid: PGUID;           ); //* case PT_CLSID         */
      PT_I8         : (li: LARGE_INTEGER;       ); //* case PT_I8            */
      PT_MV_I2      : (MVi: SShortArray;        ); //* case PT_MV_I2         */
      PT_MV_LONG    : (MVl: SLongArray;         ); //* case PT_MV_LONG       */
      PT_MV_R4      : (MVflt: SRealArray;       ); //* case PT_MV_R4         */
      PT_MV_DOUBLE  : (MVdbl: SDoubleArray;     ); //* case PT_MV_DOUBLE     */
      PT_MV_CURRENCY: (MVcur: SCurrencyArray;   ); //* case PT_MV_CURRENCY   */
      PT_MV_APPTIME : (MVat: SAppTimeArray;     ); //* case PT_MV_APPTIME    */
      PT_MV_SYSTIME : (MVft: SDateTimeArray;    ); //* case PT_MV_SYSTIME    */
      PT_MV_BINARY  : (MVbin: SBinaryArray;     ); //* case PT_MV_BINARY     */
      PT_MV_STRING8 : (MVszA: SLPSTRArray;      ); //* case PT_MV_STRING8    */
      PT_MV_UNICODE : (MVszW: SWStringArray;    ); //* case PT_MV_UNICODE    */
      PT_MV_CLSID   : (MVguid: SGuidArray;      ); //* case PT_MV_CLSID      */
      PT_MV_I8      : (MVli: SLargeIntegerArray;); //* case PT_MV_I8         */
      PT_ERROR      : (err: SCODE;              ); //* case PT_ERROR         */
      PT_NULL, PT_OBJECT: (x: LONG;             ); //* case PT_NULL, PT_OBJECT (no usable value) */
  end;

  SPropValue = packed record
    ulPropTag: ULONG;
    dwAlignPad: ULONG;
    Value: _PV;
  end;
  LPSPropValue = ^SPropValue;
  LPPSPropValue = ^LPSPropValue;

//* --------------------------------------------- */
//* Property Problem and Property Problem Arrays */
//* --------------------------------------------- */
  SPropProblem = packed record
    ulIndex: ULONG;
    ulPropTag: ULONG;
    scode: SCODE;
  end;
  LPSPropProblem = ^SPropProblem;

  SPropProblemArray = packed record
    cProblem: ULONG;
    aProblem: array[0..MAPI_DIM-1] of SPropProblem;
  end;
  LPSPropProblemArray = ^SPropProblemArray;
  LPPSPropProblemArray = ^LPSPropProblemArray;

  LPSRestriction = Pointer;
  LPPSRestriction = ^LPSRestriction;

  //* ------------------------------ */
  //* SRow, SRowSet */

  SRow = packed record
    ulAdrEntryPad: ULONG;  //* Pad so SRow's can map to ADRENTRY's */
    cValues: ULONG;        //* Count of property values */
    lpProps: LPSPropValue;        //* Property value array */
  end;
  LPSRow = ^SRow;

  SRowSet = packed record
    cRows: ULONG;          //* Count of rows */
    aRow: array [0..MAPI_DIM-1] of SRow; //* Array of rows */
  end;
  LPSRowSet = ^SRowSet;
  LPPSRowSet = ^LPSRowSet;

  SAndRestriction = packed record
    cRes: ULONG;
    lpRes: LPSRestriction;
  end;

  SOrRestriction = packed record
    cRes: ULONG;
    lpRes: LPSRestriction;
  end;

  SNotRestriction = packed record
    ulReserved: ULONG;
    lpRes: LPSRestriction;
  end;

  SContentRestriction = packed record
    ulFuzzyLevel: ULONG;
    ulPropTag: ULONG;
    lpProp: LPSPropValue;
  end;

  SBitMaskRestriction = packed record
    relBMR: ULONG;
    ulPropTag: ULONG;
    ulMask: ULONG;
  end;

  SPropertyRestriction = packed record
    relop: ULONG;
    ulPropTag: ULONG;
    lpProp: LPSPropValue;
  end;

  SComparePropsRestriction = packed record
    relop: ULONG;
    ulPropTag1: ULONG;
    ulPropTag2: ULONG;
  end;

  SSizeRestriction = packed record
    relop: ULONG;
    ulPropTag: ULONG;
    cb: ULONG;
  end;

  SExistRestriction = packed record
    ulReserved1: ULONG;
    ulPropTag: ULONG;
    ulReserved2: ULONG;
  end;

  SSubRestriction = packed record
    ulSubObject: ULONG;
    lpRes: LPSRestriction;
  end;

  SCommentRestriction = packed record
    cValues: ULONG; //* # of properties in lpProp */
    lpRes: LPSRestriction;
    lpProp: LPSPropValue;
  end;

  SRestriction = packed record
    rt: ULONG;         //* Restriction type */
    case ULONG of
      0:  (resCompareProps: SComparePropsRestriction;);
      1:  (resAnd:          SAndRestriction;);
      2:  (resOr:           SOrRestriction;);
      3:  (resNot:          SNotRestriction;);
      4:  (resContent:      SContentRestriction;);
      5:  (resProperty:     SPropertyRestriction;);
      6:  (resBitMask:      SBitMaskRestriction;);
      7:  (resSize:         SSizeRestriction;);
      8:  (resExist:        SExistRestriction;);
      9:  (resSub:          SSubRestriction;);
      10: (resComment:      SCommentRestriction;);
  end;

  //* Event Structures */
  ERROR_NOTIFICATION = packed record
    cbEntryID: ULONG;
    lpEntryID: LPENTRYID;
    scode: SCODE;
    ulFlags: ULONG;            //* 0 or MAPI_UNICODE */
    lpMAPIError: LPMAPIERROR;        //* Detailed error information */
  end;

  NEWMAIL_NOTIFICATION = packed record
    cbEntryID: ULONG;
    lpEntryID: LPENTRYID;          //* identifies the new message */
    cbParentID: ULONG;
    lpParentID: LPENTRYID;         //* identifies the folder it lives in */
    ulFlags: ULONG;            //* 0 or MAPI_UNICODE */
    lpszMessageClass: pChar;   //* message class (UNICODE or string8) */
    ulMessageFlags: ULONG;     //* copy of PR_MESSAGE_FLAGS */
  end;

  OBJECT_NOTIFICATION = packed record
    cbEntryID:      ULONG         ;
    lpEntryID:      LPENTRYID     ; //* EntryID of object */
    ulObjType:      ULONG         ; //* Type of object */
    cbParentID:     ULONG         ;
    lpParentID:     LPENTRYID     ; //* EntryID of parent object */
    cbOldID:        ULONG         ;
    lpOldID:        LPENTRYID     ; //* EntryID of old object */
    cbOldParentID:  ULONG         ;
    lpOldParentID:  LPENTRYID     ; //* EntryID of old parent */
    lpPropTagArray: LPSPropTagArray;
  end;

  TABLE_NOTIFICATION = packed record
    ulTableEvent:   ULONG        ;  //* Identifies WHICH table event */
    hResult:        HRESULT      ;  //* Value for TABLE_ERROR */
    propIndex:      SPropValue   ;  //* This row's "index property" */
    propPrior:      SPropValue   ;  //* Preceding row's "index property" */
    row:            SRow         ;  //* New data of added/modified row */
    ulPad:          ULONG        ;  //* Force to 8-byte boundary */
  end;

  EXTENDED_NOTIFICATION = packed record
        ulEvent:                ULONG    ;     //* extended event code */
        cb:                     ULONG    ;     //* size of event parameters */
        pbEventParameters:      LPBYTE   ;     //* event parameters */
  end;

  STATUS_OBJECT_NOTIFICATION = packed record
    cbEntryID:   ULONG        ;
    lpEntryID:   LPENTRYID    ;
    cValues:     ULONG        ;
    lpPropVals:  LPSPropValue ;
  end;

  NOTIFICATION = packed record
    ulEventType: ULONG;        //* notification type, i.e. fnevSomething */
    ulAlignPad: ULONG;         //* Force to 8-byte boundary */
    case byte of
        0: (err:     ERROR_NOTIFICATION;);
        1: (newmail: NEWMAIL_NOTIFICATION;);
        2: (obj:     OBJECT_NOTIFICATION;);
        3: (tab:     TABLE_NOTIFICATION;);
        4: (ext:     EXTENDED_NOTIFICATION;);
        5: (statobj: STATUS_OBJECT_NOTIFICATION;);
  end;
  LPNOTIFICATION = ^NOTIFICATION;

  //* ------------------------------ */
  //* ADRENTRY, ADRLIST */
  ADRENTRY = packed record
    ulReserved1: ULONG;    //* Never used */
    cValues: ULONG;
    rgPropVals: LPSPropValue;
  end;
  LPADRENTRY = ^ADRENTRY;

  ADRLIST = packed record
    cEntries: ULONG;
    aEntries: array [0..MAPI_DIM-1] of ADRENTRY;
  end;
  LPADRLIST = ^ADRLIST;
  LPPADRLIST = ^LPADRLIST;

  MAPINAMEID = packed record
    lpguid: PGUID;
    ulKind: ULONG;
    case byte of
      0: (lID: LONG;);
      1: (lpwstrName: pWideChar;);
  end;
  LPMAPINAMEID = ^MAPINAMEID;
  LPPMAPINAMEID = ^LPMAPINAMEID;
  LPPPMAPINAMEID = ^LPPMAPINAMEID;


  //*  Accelerator callback for DIALOG_SDI form of AB UI */
  LPFNABSDI = function(ulUIParam: ULONG; lpvmsg: Pointer): BOOL; stdcall;

  //*  Callback to application telling it that the DIALOG_SDI form of the */
  //*  AB UI has been dismissed.  This is so that the above LPFNABSDI     */
  //*  function doesn't keep being called.                                */
  LPFNDISMISS = procedure(ulUIParam: ULONG; lpvContext: Pointer); stdcall;

  //*
  // * Prototype for the client function hooked to an optional button on
  // * the address book dialog
  // */
  LPFNBUTTON = function(ulUIParam: ULONG; lpvContext: Pointer; cbEntryID: ULONG; lpSelection: LPENTRYID; ulFlags: ULONG): SCODE; stdcall;


  //* Parameters for the address book dialog */
  ADRPARM = packed record
    cbABContEntryID           :ULONG;
    lpABContEntryID           :LPENTRYID;
    ulFlags                   :ULONG;
    lpReserved                :Pointer;
    ulHelpContext             :ULONG;
    lpszHelpFileName          :pChar;
    lpfnABSDI                 :LPFNABSDI;
    lpfnDismiss               :LPFNDISMISS;
    lpvDismissContext         :Pointer;
    lpszCaption               :pChar;
    lpszNewEntryTitle         :pChar;
    lpszDestWellsTitle        :pChar;
    cDestFields               :ULONG;
    nDestFieldFocus           :ULONG;
    lppszDestTitles           :ppChar;
    lpulDestComps             :PULONG;
    lpContRestriction         :LPSRestriction;
    lpHierRestriction         :LPSRestriction;
  end;
  LPADRPARM = ^ADRPARM;

  LPALLOCATEBUFFER = function(cbSize: ULONG; lppBuffer: Pointer): SCODE; stdcall;
  LPFREEBUFFER = function(lpBuffer: Pointer): ULONG; stdcall;

  {IMAPIProp Interface -----------------------------------------------------}
  IMAPIProp = interface
    function GetLastError(hResult: HRESULT; ulFlags: ULONG; lppMAPIError: LPPMAPIERROR): HRESULT; stdcall;
    function SaveChanges(ulFlags: ULONG): HRESULT; stdcall;
    function GetProps(lpPropTagArray: LPSPropTagArray; ulFlags: ULONG; lpcValues: PULONG; lppPropArray: LPPSPropValue): HRESULT; stdcall;
    function GetPropList(ulFlags: ULONG; lppPropTagArray: LPPSPropTagArray): HRESULT; stdcall;
    function OpenProperty(ulPropTag: ULONG; lpiid: PGUID; ulInterfaceOptions: ULONG; ulFlags: ULONG; lppUnk: LPUNKNOWN): HRESULT; stdcall;
    function SetProps(cValues: ULONG; lpPropArray: LPSPropValue; lppProblems: LPPSPropProblemArray): HRESULT; stdcall;
    function DeleteProps(lpPropTagArray: LPSPropTagArray; lppProblems: LPPSPropProblemArray): HRESULT; stdcall;
    function CopyTo(ciidExclude: ULONG; rgiidExclude: PGUID; lpExcludeProps: LPSPropTagArray; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; lpInterface: PGUID; lpDestObj: Pointer; ulFlags: ULONG; lppProblems: LPPSPropProblemArray): HRESULT; stdcall;
    function CopyProps(lpIncludeProps: LPSPropTagArray; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; lpInterface: PGUID; lpDestObj: Pointer; ulFlags: ULONG; lppProblems: LPPSPropProblemArray): HRESULT; stdcall;
    function GetNamesFromIDs(lppPropTags: LPPSPropTagArray; lpPropSetGuid: PGUID; ulFlags: ULONG; lpcPropNames: PULONG; lpppPropNames: LPPPMAPINAMEID): HRESULT; stdcall;
    function GetIDsFromNames(cPropNames: ULONG; lppPropNames: LPPMAPINAMEID; ulFlags: ULONG; lppPropTags: LPPSPropTagArray): HRESULT; stdcall;
  end;

  {IMAPIStatus Interface -------------------------------------------------}
  IMAPIStatus = interface(IMAPIProp)
    function ValidateState(ulUIParam: ULONG; ulFlags: ULONG): HRESULT; stdcall;
    function SettingsDialog(ulUIParam: ULONG; ulFlags: ULONG): HRESULT; stdcall;
    function ChangePassword(lpOldPass: pChar; lpNewPass: pChar; ulFlags: ULONG): HRESULT; stdcall;
    function FlushQueues(ulUIParam: ULONG; cbTargetTransport: ULONG; lpTargetTransport: LPENTRYID; ulFlags: ULONG): HRESULT; stdcall;
  end;

  {IMAPIProgress Interface -------------------------------------------------}
  IMAPIProgress = interface
    function Progress(ulValue: ULONG; ulCount: ULONG; ulTotal: ULONG): HRESULT; stdcall;
    function GetFlags(lpulFlags: PULONG): HRESULT; stdcall;
    function GetMax(lpulMax: PULONG): HRESULT; stdcall;
    function GetMin(lpulMin: PULONG): HRESULT; stdcall;
    function SetLimits(lpulMin: PULONG; lpulMax: PULONG; lpulFlags: PULONG): HRESULT; stdcall;
  end;

  {IMAPIAdviseSink Interface -----------------------------------------------}
  IMAPIAdviseSink = interface
    function OnNotify(cNotif: ULONG; lpNotifications: LPNOTIFICATION): ULONG; stdcall;
  end;

  {IMAPITable Interface ----------------------------------------------------}
  IMAPITable = interface
    function GetLastError(hResult: HRESULT; ulFlags: ULONG; lppMAPIError: LPPMAPIERROR): HRESULT; stdcall;
    function Advise(ulEventMask: ULONG; lpAdviseSink: LPMAPIADVISESINK; lpulConnection: PULONG): HRESULT; stdcall;
    function Unadvise(ulConnection: ULONG): HRESULT; stdcall;
    function GetStatus(lpulTableStatus: PULONG; lpulTableType: PULONG): HRESULT; stdcall;
    function SetColumns(lpPropTagArray: LPSPropTagArray; ulFlags: ULONG): HRESULT; stdcall;
    function QueryColumns(ulFlags: ULONG; lpPropTagArray: LPPSPropTagArray): HRESULT; stdcall;
    function GetRowCount(ulFlags: ULONG; lpulCount: PULONG): HRESULT; stdcall;
    function SeekRow(bkOrigin: BOOKMARK; lRowCount: LONG; lplRowsSought: PLONG): HRESULT; stdcall;
    function SeekRowApprox(ulNumerator: ULONG; ulDenominator: ULONG): HRESULT; stdcall;
    function QueryPosition(lpulRow: PULONG; lpulNumerator: PULONG; lpulDenominator: PULONG): HRESULT; stdcall;
    function FindRow(lpRestriction: LPSRestriction; bkOrigin: BOOKMARK; ulFlags: ULONG): HRESULT; stdcall;
    function Restrict(lpRestriction: LPSRestriction; ulFlags: ULONG): HRESULT; stdcall;
    function CreateBookmark(lpbkPosition: PBOOKMARK): HRESULT; stdcall;
    function FreeBookmark(bkPosition: BOOKMARK): HRESULT; stdcall;
    function SortTable(lpSortCriteria: LPSSortOrderSet; ulFlags: ULONG): HRESULT; stdcall;
    function QuerySortOrder(lppSortCriteria: LPPSSortOrderSet): HRESULT; stdcall;
    function QueryRows(lRowCount: LONG; ulFlags: ULONG; lppRows: LPPSRowSet): HRESULT; stdcall;
    function Abort: HRESULT; stdcall;
    function ExpandRow(cbInstanceKey: ULONG; pbInstanceKey: LPBYTE; ulRowCount: ULONG; ulFlags: ULONG; lppRows: LPPSRowSet; lpulMoreRows: PULONG): HRESULT; stdcall;
    function CollapseRow(cbInstanceKey: ULONG; pbInstanceKey: LPBYTE; ulFlags: ULONG; lpulRowCount: PULONG): HRESULT; stdcall;
    function WaitForCompletion(ulFlags: ULONG; ulTimeout: ULONG; lpulTableStatus: PULONG): HRESULT; stdcall;
    function GetCollapseState(ulFlags: ULONG; cbInstanceKey: ULONG; lpbInstanceKey: LPBYTE; lpcbCollapseState: PULONG; lppbCollapseState: LPPBYTE): HRESULT; stdcall;
    function SetCollapseState(ulFlags: ULONG; cbCollapseState: ULONG; pbCollapseState: LPBYTE; lpbkLocation: PBOOKMARK): HRESULT; stdcall;
  end;

  {IMsgStore Interface -----------------------------------------------------}
  IMsgStore = interface(IMAPIProp)
    function Advise(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulEventMask: ULONG; lpAdviseSink: LPMAPIADVISESINK; lpulConnection: PULONG): HRESULT; stdcall;
    function Unadvise(ulConnection: ULONG): HRESULT; stdcall;
    function CompareEntryIDs(cbEntryID1: ULONG; lpEntryID1: LPENTRYID; cbEntryID2: ULONG; lpEntryID2: LPENTRYID; ulFlags: ULONG; lpulResult: PULONG): HRESULT; stdcall;
    function OpenEntry(cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; ulFlags: ULONG; lpulObjType: PULONG; lppUnk: LPPUNKNOWN): HRESULT; stdcall;
    function SetReceiveFolder(lpszMessageClass: pChar; ulFlags: ULONG; cbEntryID: ULONG; lpEntryID: LPENTRYID): HRESULT; stdcall;
    function GetReceiveFolder(lpszMessageClass: pChar; ulFlags: ULONG; lpcbEntryID: PULONG; lppEntryID: LPPENTRYID; lppszExplicitClass: ppChar): HRESULT; stdcall;
    function GetReceiveFolderTable(ulFlags: ULONG; lppTable: LPPMAPITABLE): HRESULT; stdcall;
    function StoreLogoff(lpulFlags: PULONG): HRESULT; stdcall;
    function AbortSubmit(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulFlags: ULONG): HRESULT; stdcall;
    function GetOutgoingQueue(ulFlags: ULONG; lppTable: LPPMAPITABLE): HRESULT; stdcall;
    function SetLockState(lpMessage: LPMESSAGE; ulLockState: ULONG): HRESULT; stdcall;
    function FinishedMsg(ulFlags: ULONG; cbEntryID: ULONG; lpEntryID: LPENTRYID): HRESULT; stdcall;
    function NotifyNewMail(lpNotification: LPNOTIFICATION): HRESULT; stdcall;
  end;

  IAddrBook = interface(IMAPIProp)
    function OpenEntry(cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; ulFlags: ULONG; lpulObjType: PLONG; lppUnk: LPPUNKNOWN): HRESULT; stdcall;
    function CompareEntryIDs(cbEntryID1: ULONG; lpEntryID1: LPENTRYID; cbEntryID2: ULONG; lpEntryID2: LPENTRYID; ulFlags: ULONG; lpulResult: PULONG): HRESULT; stdcall;
    function Advise(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulEventMask: ULONG; lpAdviseSink: LPMAPIADVISESINK; lpulConnection: PULONG): HRESULT; stdcall;
    function Unadvise(ulConnection: ULONG): HRESULT; stdcall;
    function CreateOneOff(lpszName: pChar; lpszAdrType: pChar; lpszAddress: pChar; ulFlags: ULONG; lpcbEntryID: PULONG; lppEntryID: LPPENTRYID): HRESULT; stdcall;
    function NewEntry(ulUIParam: ULONG; ulFlags: ULONG; cbEIDContainer: ULONG; lpEIDContainer: LPENTRYID; cbEIDNewEntryTpl: ULONG; lpEIDNewEntryTpl: LPENTRYID; lpcbEIDNewEntry: PULONG; lppEIDNewEntry: LPPENTRYID): HRESULT; stdcall;
    function ResolveName(ulUIParam: ULONG; ulFlags: ULONG; lpszNewEntryTitle: pChar; lpAdrList: LPADRLIST): HRESULT; stdcall;
    function Address(lpulUIParam: PULONG; lpAdrParms: LPADRPARM; lppAdrList: LPPADRLIST): HRESULT; stdcall;
    function Details(lpulUIParam: PULONG; lpfnDismiss: LPFNDISMISS; lpvDismissContext: Pointer; cbEntryID: ULONG; lpEntryID: LPENTRYID; lpfButtonCallback: LPFNBUTTON; lpvButtonContext: Pointer; lpszButtonText: pChar; ulFlags: ULONG): HRESULT; stdcall;
    function RecipOptions(ulUIParam: ULONG; ulFlags: ULONG; lpRecip: LPADRENTRY): HRESULT; stdcall;
    function QueryDefaultRecipOpt(lpszAdrType: pChar; ulFlags: ULONG; lpcValues: PULONG; lppOptions: LPPSPropValue): HRESULT; stdcall;
    function GetPAB(lpcbEntryID: PULONG; lppEntryID: LPPENTRYID): HRESULT; stdcall;
    function SetPAB(cbEntryID: ULONG; lpEntryID: LPENTRYID): HRESULT; stdcall;
    function GetDefaultDir(lpcbEntryID: PULONG; lppEntryID: LPPENTRYID): HRESULT; stdcall;
    function SetDefaultDir(cbEntryID: ULONG; lpEntryID: LPENTRYID): HRESULT; stdcall;
    function GetSearchPath(ulFlags: ULONG; lppSearchPath: LPPSRowSet): HRESULT; stdcall;
    function SetSearchPath(ulFlags: ULONG; lpSearchPath: LPSRowSet): HRESULT; stdcall;
    function PrepareRecips(ulFlags: ULONG; lpPropTagArray: LPSPropTagArray; lpRecipList: LPADRLIST): HRESULT; stdcall;
  end;

  IProfSect = interface(IMAPIProp)
  end;

  IAttach = interface(IMAPIProp)
  end;

  IMAPIMessage = interface(IMAPIProp)
    function GetAttachmentTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function OpenAttach(ulAttachmentNum: ULONG; lpInterface: PGUID; ulFlags: ULONG; lppAttach: LPATTACH): HRESULT; stdcall;
    function CreateAttach(lpInterface: PGUID; ulFlags: ULONG; lpulAttachmentNum: PULONG; lppAttach: LPATTACH): HRESULT; stdcall;
    function DeleteAttach(ulAttachmentNum: ULONG; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function GetRecipientTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function ModifyRecipients(ulFlags: ULONG; lpMods: LPADRLIST): HRESULT; stdcall;
    function SubmitMessage(ulFlags: ULONG): HRESULT; stdcall;
    function SetReadFlag(ulFlags: ULONG): HRESULT; stdcall;
  end;

  IProviderAdmin = interface
    function GetLastError(hResult: HRESULT; ulFlags: ULONG; lppMAPIError: LPPMAPIERROR): HRESULT; stdcall;
    function GetProviderTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function CreateProvider(lpszProvider: pChar; cValues: ULONG; lpProps: LPSPropValue; ulUIParam: ULONG; ulFlags: ULONG; lpUID: LPMAPIUID): HRESULT; stdcall;
    function DeleteProvider(lpUID: LPMAPIUID): HRESULT; stdcall;
    function OpenProfileSection(lpUID: LPMAPIUID; lpInterface: PGUID; ulFlags: ULONG; lppProfSect: LPPROFSECT): HRESULT; stdcall;
  end;

  IMsgServiceAdmin = interface
    function GetLastError(hResult: HRESULT; ulFlags: ULONG; lppMAPIError: LPPMAPIERROR): HRESULT; stdcall;
    function GetMsgServiceTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function CreateMsgService(lpszService: pChar; lpszDisplayName: pChar; ulUIParam: ULONG; ulFlags: ULONG): HRESULT; stdcall;
    function DeleteMsgService(lpUID: LPMAPIUID): HRESULT; stdcall;
    function CopyMsgService(lpUID: LPMAPIUID; lpszDisplayName: pChar; lpInterfaceToCopy: PGUID; lpInterfaceDst: PGUID; lpObjectDst: Pointer; ulUIParam: ULONG; ulFlags: ULONG): HRESULT; stdcall;
    function RenameMsgService(lpUID: LPMAPIUID; ulFlags: ULONG; lpszDisplayName: pChar): HRESULT; stdcall;
    function ConfigureMsgService(lpUID: LPMAPIUID; ulUIParam: ULONG; ulFlags: ULONG; cValues: ULONG; lpProps: LPSPropValue): HRESULT; stdcall;
    function OpenProfileSection(lpUID: LPMAPIUID; lpInterface: PGUID; ulFlags: ULONG; lppProfSect: LPPROFSECT): HRESULT; stdcall;
    function MsgServiceTransportOrder(cUID: ULONG; lpUIDList: LPMAPIUID; ulFlags: ULONG): HRESULT; stdcall;
    function AdminProviders(lpUID: LPMAPIUID; ulFlags: ULONG; lppProviderAdmin: LPPROVIDERADMIN): HRESULT; stdcall;
    function SetPrimaryIdentity(lpUID: LPMAPIUID; ulFlags: ULONG): HRESULT; stdcall;
    function GetProviderTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
  end;

  IMAPIContainer = interface(IMAPIProp)
    function GetContentsTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function GetHierarchyTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function OpenEntry(cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; ulFlags: ULONG; lpulObjType: PULONG; lppUnk: LPUNKNOWN): HRESULT; stdcall;
    function SetSearchCriteria(lpRestriction: LPSRestriction; lpContainerList: LPENTRYLIST; ulSearchFlags: ULONG): HRESULT; stdcall;
    function GetSearchCriteria(ulFlags: ULONG; lppRestriction: LPPSRestriction; lppContainerList: LPPENTRYLIST; lpulSearchState: PULONG): HRESULT; stdcall;
  end;

  IMAPIFolder = interface(IMAPIContainer)
    function CreateMessage(lpInterface: PGUID; ulFlags: ULONG; lppMessage: LPPMESSAGE): HRESULT; stdcall;
    function CopyMessages(lpMsgList: LPENTRYLIST; lpInterface: PGUID; lpDestFolder: Pointer; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function DeleteMessages(lpMsgList: LPENTRYLIST; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function CreateFolder(ulFolderType: ULONG; lpszFolderName: pChar; lpszFolderComment: pChar; lpInterface: PGUID; ulFlags: ULONG; lppFolder: LPPMAPIFOLDER): HRESULT; stdcall;
    function CopyFolder(cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; lpDestFolder: Pointer; lpszNewFolderName: pChar; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function DeleteFolder(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function SetReadFlags(lpMsgList: LPENTRYLIST; ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
    function GetMessageStatus(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulFlags: ULONG; lpulMessageStatus: PULONG): HRESULT; stdcall;
    function SetMessageStatus(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulNewStatus: ULONG; ulNewStatusMask: ULONG; lpulOldStatus: PULONG): HRESULT; stdcall;
    function SaveContentsSort(lpSortCriteria: LPSSortOrderSet; ulFlags: ULONG): HRESULT; stdcall;
    function EmptyFolder(ulUIParam: ULONG; lpProgress: LPMAPIPROGRESS; ulFlags: ULONG): HRESULT; stdcall;
  end;

  {IMAPISession Interface --------------------------------------------------}
  IMAPISession = interface
    function GetLastError(hResult: HRESULT; ulFlags: ULONG; lppMAPIError: LPPMAPIERROR): HRESULT; stdcall;
    function GetMsgStoresTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT;  stdcall;
    function OpenMsgStore(ulUIParam: ULONG; cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; ulFlags: ULONG; lppMDB: LPMDB): HRESULT; stdcall;
    function OpenAddressBook(ulUIParam: ULONG; lpInterface: PGUID; ulFlags: ULONG; lppAdrBook: LPADRBOOK): HRESULT; stdcall;
    function OpenProfileSection(lpUID: LPMAPIUID; lpInterface: PGUID; ulFlags: ULONG; lppProfSect: LPPROFSECT): HRESULT; stdcall;
    function GetStatusTable(ulFlags: ULONG; lppTable: LPMAPITABLE): HRESULT; stdcall;
    function OpenEntry(cbEntryID: ULONG; lpEntryID: LPENTRYID; lpInterface: PGUID; ulFlags: ULONG; lpulObjType: PULONG; lppUnk: LPUNKNOWN): HRESULT; stdcall;
    function CompareEntryIDs(cbEntryID1: ULONG; lpEntryID1: LPENTRYID; cbEntryID2: ULONG; lpEntryID2: LPENTRYID; ulFlags: ULONG; lpulResult: PULONG): HRESULT; stdcall;
    function Advise(cbEntryID: ULONG; lpEntryID: LPENTRYID; ulEventMask: ULONG; lpAdviseSink: LPMAPIADVISESINK; lpulConnection: PULONG): HRESULT; stdcall;
    function Unadvise(ulConnection: ULONG): HRESULT; stdcall;
    function MessageOptions(ulUIParam: ULONG; ulFlags: ULONG; lpszAdrType: pChar; lpMessage: LPMESSAGE): HRESULT; stdcall;
    function QueryDefaultMessageOpt(lpszAdrType: pChar; ulFlags: ULONG; lpcValues: PULONG; lppOptions: LPPSPropValue): HRESULT; stdcall;
    function EnumAdrTypes(ulFlags: ULONG; lpcAdrTypes: PULONG; lpppszAdrTypes: PPPCHAR): HRESULT; stdcall;
    function QueryIdentity(lpcbEntryID: PULONG; lppEntryID: LPPENTRYID): HRESULT; stdcall;
    function Logoff(ulUIParam, ulFlags, ulReserved: ULONG): HRESULT; stdcall;
    function SetDefaultStore(ulFlags: ULONG; cbEntryID: ULONG; lpEntryID: LPENTRYID): HRESULT; stdcall;
    function AdminServices(ulFlags: ULONG; lppServiceAdmin: LPSERVICEADMIN): HRESULT; stdcall;
    function ShowForm(ulUIParam: ULONG; lpMsgStore: LPMDB; lpParentFolder: LPMAPIFOLDER; lpInterface: PGUID; ulMessageToken: ULONG; lpMessageSent: LPMESSAGE; ulFlags: ULONG; ulMessageStatus: ULONG; ulMessageFlags: ULONG; ulAccess: ULONG; lpszMessageClass: pChar): HRESULT; stdcall;
    function PrepareForm(lpInterface: PGUID; lpMessage: LPMESSAGE; lpulMessageToken: PULONG): HRESULT; stdcall;
  end;

  {Structure passed to MAPIInitialize(), and its ulFlags values}

  MAPIINIT_0 = packed record
    ulVersion:    ULONG;
    ulFlags:      ULONG;
  end;
  pMAPIINIT_0 = ^MAPIINIT_0;


  //Forward class declarations
  TMAPISession = class;

  {TLogonFlags}
  TMAPILogonFlags = class(TPersistent)
  private
    FLOGON_UI:           boolean;
    FNEW_SESSION:        boolean;
    FALLOW_OTHERS:       boolean;
    FEXPLICIT_PROFILE:   boolean;
    FEXTENDED:           boolean;
    FFORCE_DOWNLOAD:     boolean;
    FSERVICE_UI_ALWAYS:  boolean;
    FNO_MAIL:            boolean;
    FNT_SERVICE:         boolean;
    FPASSWORD_UI:        boolean;
    FTIMEOUT_SHORT:      boolean;
    FUSE_DEFAULT:        boolean;
    function GetLogonFlag: ULONG;
  public
    constructor Create;
    property LogonFlag: ULONG read GetLogonFlag;
  published
    property LOGON_UI:           boolean read FLOGON_UI           write FLOGON_UI;
    property NEW_SESSION:        boolean read FNEW_SESSION        write FNEW_SESSION;
    property ALLOW_OTHERS:       boolean read FALLOW_OTHERS       write FALLOW_OTHERS;
    property EXPLICIT_PROFILE:   boolean read FEXPLICIT_PROFILE   write FEXPLICIT_PROFILE;
    property EXTENDED:           boolean read FEXTENDED           write FEXTENDED;
    property FORCE_DOWNLOAD:     boolean read FFORCE_DOWNLOAD     write FFORCE_DOWNLOAD;
    property SERVICE_UI_ALWAYS:  boolean read FSERVICE_UI_ALWAYS  write FSERVICE_UI_ALWAYS;
    property NO_MAIL:            boolean read FNO_MAIL            write FNO_MAIL;
    property NT_SERVICE:         boolean read FNT_SERVICE         write FNT_SERVICE;
    property PASSWORD_UI:        boolean read FPASSWORD_UI        write FPASSWORD_UI;
    property TIMEOUT_SHORT:      boolean read FTIMEOUT_SHORT      write FTIMEOUT_SHORT;
    property USE_DEFAULT:        boolean read FUSE_DEFAULT        write FUSE_DEFAULT;
  end;

  {TLogoffFlags}
  TMAPILogoffFlags = class(TPersistent)
  private
    FLOGOFF_SHARED: boolean;
    FLOGOFF_UI: boolean;
    function GetLogoffFlag: ULONG;
  public
    constructor Create;
    property LogoffFlag: ULONG read GetLogoffFlag;
  published
    property LOGOFF_SHARED: boolean read FLOGOFF_SHARED write FLOGOFF_SHARED;
    property LOGOFF_UI: boolean read FLOGOFF_UI write FLOGOFF_UI;
  end;

  {TMessageFlags}
  TMessageFlags = class(TPersistent)
  private
    FREAD            : boolean;
    FUNMODIFIED      : boolean;
    FSUBMIT          : boolean;
    FUNSENT          : boolean;
    FHASATTACH       : boolean;
    FFROMME          : boolean;
    FASSOCIATED      : boolean;
    FRESEND          : boolean;
    FRN_PENDING      : boolean;
    FNRN_PENDING     : boolean;
    function GetMessageFlag: ULONG;
    procedure SetMessageFlag(const Value: ULONG);
  public
    constructor Create;
  published
    property MessageFlag: ULONG read GetMessageFlag write SetMessageFlag;
    property _READ           : boolean read FREAD            write FREAD            ;
    property UNMODIFIED      : boolean read FUNMODIFIED      write FUNMODIFIED      ;
    property SUBMIT          : boolean read FSUBMIT          write FSUBMIT          ;
    property UNSENT          : boolean read FUNSENT          write FUNSENT          ;
    property HASATTACH       : boolean read FHASATTACH       write FHASATTACH       ;
    property FROMME          : boolean read FFROMME          write FFROMME          ;
    property ASSOCIATED      : boolean read FASSOCIATED      write FASSOCIATED      ;
    property RESEND          : boolean read FRESEND          write FRESEND          ;
    property RN_PENDING      : boolean read FRN_PENDING      write FRN_PENDING      ;
    property NRN_PENDING     : boolean read FNRN_PENDING     write FNRN_PENDING     ;
  end;

  TMAPIFolder = class;
  TMAPIMessage = class;
  TMAPIAttachment = class;
  TMAPIRecipient = class;

  {TMAPIRecipients}
  TMAPIRecipients = class(TOwnedCollection)
  private
    {$IFDEF VER130}
    function GetCollectionOwner: TPersistent;
    {$ENDIF}
    function GetItem(Index: Integer): TMAPIRecipient;
    procedure SetItem(Index: Integer; const Value: TMAPIRecipient);
  public
    procedure AssignValues(Value: TMAPIRecipients);
    function FindRecipient(const Value: string): TMAPIRecipient;
    function IsEqual(Value: TMAPIRecipients): Boolean;
    function CreateRecipient: TMAPIRecipient;
    {$IFDEF VER130}
    property Owner: TPersistent read GetCollectionOwner;
    {$ENDIF}
    property Items[Index: Integer]: TMAPIRecipient read GetItem write SetItem; default;
  end;

  {TMAPIRecipient}
  TMAPIRecipient = class(TCollectionItem)
  private
    FEMail: String;
    FName: String;
  protected
    procedure AssignRecipient(Recipient: TMAPIRecipient);
    function GetDisplayName: string; override;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function IsEqual(Value: TMAPIRecipient): Boolean;
  published
    property Name: String read FName write FName;
    property EMail: String read FEMail write FEMail;
  end;

  {TMAPIAttachments}
  TMAPIAttachments = class(TOwnedCollection)
  private
    {$IFDEF VER130}
    function GetCollectionOwner: TPersistent;
    {$ENDIF}
    function GetItem(Index: Integer): TMAPIAttachment;
    procedure SetItem(Index: Integer; const Value: TMAPIAttachment);
  public
    procedure AssignValues(Value: TMAPIAttachments);
    function FindAttach(const Value: string): TMAPIAttachment;
    function IsEqual(Value: TMAPIAttachments): Boolean;
    function CreateAttach(AttName, AttFileName: String; AttNum: Integer; AttInterface: IAttach): TMAPIAttachment;
    {$IFDEF VER130}
    property Owner: TPersistent read GetCollectionOwner;
    {$ENDIF}
    property Items[Index: Integer]: TMAPIAttachment read GetItem write SetItem; default;
  end;

  {TMAPIAttachment}
  TMAPIAttachment = class(TCollectionItem)
  private
    FAttachments: TMAPIAttachments;
    FAttach: IAttach;
    FAttachName: String;
    FFileName: String;
    FStream: TIStream;
    FNumber: Integer;
  protected
    procedure AssignAttach(Attach: TMAPIAttachment);
    function GetDisplayName: string; override;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function IsEqual(Value: TMAPIAttachment): Boolean;
    property AttachStream: TIStream read FStream;
    property Number: Integer read FNumber;
    property Attach: IAttach read FAttach;
  published
    property Name: String read FAttachName write FAttachName;
    property FileName: String read FFileName write FFileName;
  end;

  {TMAPIMessages}
  TMAPIMessages = class(TOwnedCollection)
  protected
    FMAPISession: TMAPISession;
    FMessagesSubmited: Boolean;
  private
    {$IFDEF VER130}
    function GetCollectionOwner: TPersistent;
    {$ENDIF}
    function GetItem(Index: Integer): TMAPIMessage;
    procedure SetItem(Index: Integer; const Value: TMAPIMessage);
    procedure SetMessagesSubmited(const Value: Boolean);
  public
    procedure AssignValues(Value: TMAPIMessages);
    function FindMessage(const Value: string): TMAPIMessage;
    function IsEqual(Value: TMAPIMessages): Boolean;
    function CreateMessage: TMAPIMessage;
    function SubmitMessages: HRESULT;
    property MAPISession: TMAPISession read FMAPISession;
    {$IFDEF VER130}
    property Owner: TPersistent read GetCollectionOwner;
    {$ENDIF}
    property Items[Index: Integer]: TMAPIMessage read GetItem write SetItem; default;
  published
    property MessagesSubmited: Boolean read FMessagesSubmited write SetMessagesSubmited;
  end;

  {TMAPIMessage}
  TMAPIMessage = class(TCollectionItem)
  private
    FIMessage: IMAPIMessage;
    FMessageFlags: TMessageFlags;
    FSUBJECT: String;
    FBODY: String;
    FREPRESENTING_NAME: String;
    FMessageID: LPSBinary;
    FMAPISession: TMAPISession;
    FAttachments: TMAPIAttachments;
    FRecipients: TMAPIRecipients;
    FSize: Integer;
    FMessageDeliveryTime: TDateTime;
    procedure SetAttachList(const Value: TMAPIAttachments);
  protected
    function GetDisplayName: string; override;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    property IMessage: IMAPIMessage read FIMessage write FIMessage;
    property MessageID: LPSBinary read FMessageID write FMessageID;
    function IsEqual(Value: TMAPIMessage): Boolean;
    function GetBody: String;
    function GetRTFBody: String;
    function SetRead(Read: Boolean):Boolean;
    property MAPISession: TMAPISession read FMAPISession;
  published
    property Attachments: TMAPIAttachments read FAttachments write SetAttachList stored False;
    property Recipients: TMAPIRecipients read FRecipients stored False;
    property REPRESENTING_NAME: String read FREPRESENTING_NAME write FREPRESENTING_NAME;
    property SUBJECT: String read FSUBJECT write FSUBJECT;
    property BODY: String read FBODY write FBODY;
    property MessageFlags: TMessageFlags read FMessageFlags;
    property Size: Integer read FSize;
    property MessageDeliveryTime: TDateTime read FMessageDeliveryTime;
  end;

  {TMAPIFolders}
  TMAPIFolders = class(TOwnedCollection)
  protected
    FMAPISession: TMAPISession;
  private
    {$IFDEF VER130}
    function GetCollectionOwner: TPersistent;
    {$ENDIF}
    function GetItem(Index: Integer): TMAPIFolder;
    procedure SetItem(Index: Integer; const Value: TMAPIFolder);
  public
    procedure AssignValues(Value: TMAPIFolders);
    function FindFolder(const Value: string): TMAPIFolder;
    function IsEqual(Value: TMAPIFolders): Boolean;
    function CreateFolder: TMAPIFolder;
    property MAPISession: TMAPISession read FMAPISession;
    {$IFDEF VER130}
    property Owner: TPersistent read GetCollectionOwner;
    {$ENDIF}
    property Items[Index: Integer]: TMAPIFolder read GetItem write SetItem; default;
  end;

  {TMAPIFolder}
  TMAPIFolder = class(TCollectionItem)
  private
    FActive: boolean;
    FFolders: TMAPIFolders;
    FMAPISession: TMAPISession;
    FFolderEID: LPSBinary;
    FIFolder: IMAPIFolder;
    FFolderType: FOLDERS_TYPE;
    FMessages: TMAPIMessages;
    FDisplayName: String;
    FSUBJECT: String;
    FCOMMENT: String;
    function GetMAPIMessage(Index: Integer): TMAPIMessage;
    function GetMAPIFolder(Index: Integer): TMAPIFolder;
    function GetFoldersCount: Integer;
    function GetMessagesCount: Integer;
    function GetActive: boolean;
    procedure SetActive(const Value: boolean);
    procedure GetMessageList;
    procedure FreeMessageList;
    procedure AssignFolder(Fold: TMAPIFolder);
    procedure SetFolderEID(const Value: LPSBinary);
    procedure GetFolderList;
    procedure FreeFolderList;
  protected
    function Open: boolean; virtual;
    function Close: boolean; virtual;
    function GetDisplayName: string; override;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function IsEqual(Value: TMAPIFolder): Boolean;
    function DeleteMessage(Index: Integer): Boolean;
    function DeleteToWaste(Index: Integer):Boolean;
    property IFolder: IMAPIFolder read FIFolder write FIFolder;
    property FolderEID: LPSBinary read FFolderEID write SetFolderEID;
    property MAPIMessage[Index: Integer]: TMAPIMessage read GetMAPIMessage;
    property MessagesCount: Integer read GetMessagesCount;
    property Folder[Index: Integer]: TMAPIFolder read GetMAPIFolder;
    property FoldersCount: Integer read GetFoldersCount;
    property MAPISession: TMAPISession read FMAPISession;
  published
    property Active: boolean read GetActive write SetActive;
    property Folders: TMAPIFolders read FFolders write FFolders;
    property Messages: TMAPIMessages read FMessages write FMessages;
    property FolderType: FOLDERS_TYPE read FFolderType write FFolderType;
    property DisplayName: String read FDisplayName write FDisplayName;
    property SUBJECT: String read FSUBJECT write FSUBJECT;
    property COMMENT: String read FCOMMENT write FCOMMENT;
  end;

  {TMAPISession}
  TMAPISession = class(TComponent)
  private
    FActive: boolean;
    FStreamedActive: boolean;
    FLogonFlags: TMAPILogonFlags;
    FLogoffFlags: TMAPILogoffFlags;
    FProfileName: String;
    FPassword: String;
    m_pMDB: IMsgStore;
    m_pSpoolerStat: IMAPIStatus;
    FWindow: HWnd;
    FMAPIInit: MAPIINIT_0;
    FFolders: TMAPIFolders;
    function GetActive: boolean;
    procedure SetActive(const Value: boolean);
    function OpenDefStore: HRESULT;
    function OpenIPMSubtree: HRESULT;
    function GetSpoolerStatus: HRESULT;
    function GetInBox: TMAPIFolder;
    function GetOutBox: TMAPIFolder;
    function GetWastBox: TMAPIFolder;
    function GetSentBox: TMAPIFolder;
  protected
    m_psbFolderEID: LPSBinary;
    m_pFolders: array[0..ORD(FOLDERS_NUM_FOLDERS) - 1] of IMAPIFolder;
    m_pSess: IMAPISession;
    m_pAddrBook: IAddrBook;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    function Open: boolean; virtual;
    function Close: boolean; virtual;
    procedure ClearInterfaces;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function FlushQs: HRESULT;
    function SimpleSend(DisplayNameRecip, sSUBJ, sBODY: String; Attachments: TStrings): HRESULT;
    property Window: HWnd read FWindow write FWindow;
    property MAPISession: IMAPISession read m_pSess;
    property AddrBook: IAddrBook read m_pAddrBook;
  published
    property Active: boolean read GetActive write SetActive;
    property LogonFlags: TMAPILogonFlags read FLogonFlags;
    property LogoffFlags: TMAPILogoffFlags read FLogoffFlags;
    property ProfileName: String read FProfileName write FProfileName;
    property Password: String read FPassword write FPassword;
    property INBOX: TMAPIFolder read GetInBox stored False;
    property OUTBOX: TMAPIFolder read GetOutBox stored False;
    property WASTEBOX: TMAPIFolder read GetWastBox stored False;
    property SENTBOX: TMAPIFolder read GetSentBox stored False;
  end;

  {MAPI Macros}
  function PROP_TYPE(ulPropTag: ULONG): ULONG;
  function PROP_ID(ulPropTag: ULONG):ULONG;
  function PROP_TAG(ulPropType,ulPropID: ULONG): ULONG;
  function CHANGE_PROP_TYPE(ulPropTag, ulPropType: ULONG): ULONG;
  function MAKE_MAPI_SCODE(sev,fac,code: ULONG): SCODE;
  function MAKE_MAPI_E(err: ULONG): HRESULT;
  function MAKE_MAPI_S(warn: ULONG): HRESULT;

  //PR_NULL                 PROP_TAG(PT_NULL, PROP_ID_NULL)

  function CopySBinary(psbDest: LPSBinary; const psbSrc: LPSBinary; pParent: Pointer): HRESULT; stdcall;
  function FileTimeToDateTime(ft: FILETIME): TDateTime;
  function LongTimeToDateTime(lt: LONG): TDateTime;

  {MAPI functions}
  function MAPIInitialize(lpMapiInit: pMAPIINIT_0): HRESULT; stdcall;
  procedure MAPIUninitialize; stdcall;
  {Extended MAPI Logon function}
  function MAPILogonEx( ulUIParam: ULONG;
                        lpszProfileName: PChar;
                        lpszPassword: PChar;
                        ulFlags: ULONG;   {ulFlags takes all that SimpleMAPI does + MAPI_UNICODE}
                        lppSession: LPMAPISESSION): HRESULT; stdcall;
  function MAPIAllocateBuffer(cbSize: ULONG; lppBuffer: Pointer): SCODE; stdcall;
  function MAPIAllocateMore(cbSize: ULONG; lpObject: Pointer; lppBuffer: Pointer): SCODE; stdcall;
  function MAPIFreeBuffer(lpBuffer: Pointer): ULONG; stdcall;
  function HrQueryAllRows( lpTable: IMAPITable;
                           lpPropTags: LPSPropTagArray;
                           lpRestriction: LPSRestriction;
                           lpSortOrderSet: LPSSortOrderSet;
                           crowsMax: LONG;
                           lppRows: LPPSRowSet): HRESULT; stdcall;
  procedure FreeProws(lpRows: LPSRowSet); stdcall;
  procedure FreePadrlist(lpAdrlist: LPADRLIST); stdcall;
  function HrGetOneProp(lpMapiProp: IMAPIProp; ulPropTag: ULONG; lppProp: LPPSPropValue): HRESULT; stdcall;
  function HrSetOneProp(lpMapiProp: IMAPIProp; lpProp: LPSPropValue): HRESULT; stdcall;
  function OpenStreamOnFile(lpAllocateBuffer: LPALLOCATEBUFFER; lpFreeBuffer: LPFREEBUFFER; ulFlags: ULONG; lpszFileName: pChar; lpszPrefix: pChar; lppStream: LPSTREAM): HRESULT; stdcall;
  function WrapCompressedRTFStream(lpCompressedRTFStream: IStream; ulflags: ULONG; var lpUncompressedRTFStream: IStream): HResult; stdcall;

  procedure Register;

implementation

  //******************************************************************************
  procedure Register;
  begin
    RegisterComponents('VK MAPI', [TMAPISession]);
  end;

  function MAPIInitialize;            stdcall; external 'MAPI32.DLL' name 'MAPIInitialize' {index 21};
  procedure MAPIUninitialize;         stdcall; external 'MAPI32.DLL' name 'MAPIUninitialize' {index 23};
  function MAPILogonEx;               stdcall; external 'MAPI32.DLL' {name 'MAPILogonEx'} index 11;
  function MAPIAllocateBuffer;        stdcall; external 'MAPI32.DLL' name 'MAPIAllocateBuffer' {index 13};
  function MAPIAllocateMore;          stdcall; external 'MAPI32.DLL' name 'MAPIAllocateMore' {index 15};
  function MAPIFreeBuffer;            stdcall; external 'MAPI32.DLL' name 'MAPIFreeBuffer' {index 17};
  function HrQueryAllRows;            stdcall; external 'MAPI32.DLL' {name 'HrQueryAllRows'} index 75;
  procedure FreeProws;                stdcall; external 'MAPI32.DLL' {name 'FreeProws'} index 140;
  procedure FreePadrlist;             stdcall; external 'MAPI32.DLL' {name 'FreePadrlist'} index 139;
  function HrGetOneProp;              stdcall; external 'MAPI32.DLL' {name 'HrGetOneProp'} index 135;
  function HrSetOneProp;              stdcall; external 'MAPI32.DLL' {name 'HrSetOneProp'} index 136;
  function OpenStreamOnFile;          stdcall; external 'MAPI32.DLL' {name 'OpenStreamOnFile'} index 147;
  function WrapCompressedRTFStream;   stdcall; external 'MAPI32.DLL' name 'WrapCompressedRTFStream';


{MAPI Macros}
  function PROP_TYPE(ulPropTag: ULONG): ULONG;
  begin
    Result := ulPropTag and PROP_TYPE_MASK;
  end;
  function PROP_ID(ulPropTag: ULONG):ULONG;
  begin
    Result := ulPropTag shr 16;
  end;
  function PROP_TAG(ulPropType,ulPropID: ULONG): ULONG;
  begin
    Result := (ulPropID shl 16) or (ulPropType);
  end;
  function CHANGE_PROP_TYPE(ulPropTag, ulPropType: ULONG): ULONG;
  begin
    Result := ($FFFF0000 and ulPropTag) or ulPropType;
  end;
  function MAKE_MAPI_SCODE(sev,fac,code: ULONG): SCODE;
  begin
    Result := (sev shl 31) or (fac shl 16) or (code);
  end;
  function MAKE_MAPI_E(err: ULONG): HRESULT;
  begin
    Result := MAKE_MAPI_SCODE(1, FACILITY_ITF, err );
  end;
  function MAKE_MAPI_S(warn: ULONG): HRESULT;
  begin
    Result := MAKE_MAPI_SCODE(0, FACILITY_ITF, warn);
  end;

function CopySBinary(psbDest: LPSBinary; const psbSrc: LPSBinary; pParent: Pointer): HRESULT; stdcall;
var
  hRes: HRESULT;
begin
  hRes := S_OK;
  psbDest.cb := psbSrc.cb;
  if (psbSrc.cb <> 0) then
  begin
    if (pParent <> nil) then
        hRes := MAPIAllocateMore(psbSrc.cb, pParent, pPointer(@psbDest.lpb))
    else
        hRes := MAPIAllocateBuffer(psbSrc.cb, pPointer(@psbDest.lpb));
    Move(psbSrc.lpb^, psbDest.lpb^, psbSrc.cb);
  end;
  Result := hRes;
end;

function FileTimeToDateTime(ft: FILETIME): TDateTime;
var
  q, w, e: Int64;
begin
  Result := EncodeDate(1601, 1, 1);
  q := ft.dwHighDateTime;
  q := q shl 32;
  q := q + ft.dwLowDateTime;
  w := Trunc(q/864000000000);
  e := q - (w * 864000000000);
  Result := Result + w + e/864000000000;
end;

function LongTimeToDateTime(lt: LONG): TDateTime;
begin
  Result := lt/864000000000;
end;

{ TMAPILogonFlags }

constructor TMAPILogonFlags.Create;
begin
  inherited Create;
  FLOGON_UI := true;
  FNEW_SESSION := false;
  FALLOW_OTHERS := true;
  FEXPLICIT_PROFILE := false;
  FEXTENDED := false;
  FFORCE_DOWNLOAD := true;
  FSERVICE_UI_ALWAYS := false;
  FNO_MAIL := false;
  FNT_SERVICE := false;
  FPASSWORD_UI := false;
  FTIMEOUT_SHORT := false;
  FUSE_DEFAULT := true;
end;

function TMAPILogonFlags.GetLogonFlag: ULONG;
begin
  Result := 0;
  if FLOGON_UI            then Result := Result or MAPI_LOGON_UI         ;
  if FNEW_SESSION         then Result := Result or MAPI_NEW_SESSION      ;
  if FALLOW_OTHERS        then Result := Result or MAPI_ALLOW_OTHERS     ;
  if FEXPLICIT_PROFILE    then Result := Result or MAPI_EXPLICIT_PROFILE ;
  if FEXTENDED            then Result := Result or MAPI_EXTENDED         ;
  if FFORCE_DOWNLOAD      then Result := Result or MAPI_FORCE_DOWNLOAD   ;
  if FSERVICE_UI_ALWAYS   then Result := Result or MAPI_SERVICE_UI_ALWAYS;
  if FNO_MAIL             then Result := Result or MAPI_NO_MAIL          ;
  if FNT_SERVICE          then Result := Result or MAPI_NT_SERVICE       ;
  if FPASSWORD_UI         then Result := Result or MAPI_PASSWORD_UI      ;
  if FTIMEOUT_SHORT       then Result := Result or MAPI_TIMEOUT_SHORT    ;
  if FUSE_DEFAULT         then Result := Result or MAPI_USE_DEFAULT      ;
end;

{ TMAPISession }

procedure TMAPISession.ClearInterfaces;
var
  i: Integer;
begin
  m_pSpoolerStat := nil;
  for i := 0 to ORD(FOLDERS_NUM_FOLDERS) - 1 do
      m_pFolders[i] := nil;
  m_pAddrBook := nil;
  m_pMDB      := nil;
  m_pSess     := nil;
end;

function TMAPISession.Close: boolean;
var
  hr: HRESULT;
begin
  Result := FActive;
  if FActive then
  begin
    hr := m_pSess.Logoff(FWindow, FLogoffFlags.LogoffFlag, 0);
    if not FAILED(hr) then
      Result := false;
  end;
  INBOX.Active := False;
  OUTBOX.Active := False;
  WASTEBOX.Active := False;
  SENTBOX.Active := False;
  if not Result then
    ClearInterfaces;
end;

constructor TMAPISession.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FMAPIInit.ulVersion := 0;
  FMAPIInit.ulFlags := MAPI_MULTITHREAD_NOTIFICATIONS;
  MAPIInitialize(@FMAPIInit);
  FLogonFlags := TMAPILogonFlags.Create;
  FLogoffFlags := TMAPILogoffFlags.Create;
  FFolders := TMAPIFolders.Create(self, TMAPIFolder);
  FFolders.FMAPISession := self;
  FWindow := 0;
  FProfileName := '';
  FPassword := '';
  FActive := false;
  ClearInterfaces;
  m_psbFolderEID := nil;
  MAPIAllocateBuffer(ORD(FOLDERS_NUM_FOLDERS)*SizeOf(SBinary), @m_psbFolderEID);
  with FFolders.Add do
    DisplayName := 'INBOX';
  with FFolders.Add do
    DisplayName := 'OUTBOX';
  with FFolders.Add do
    DisplayName := 'WASTEBOX';
  with FFolders.Add do
    DisplayName := 'SENTBOX';
  //FINBOX := TMAPIFolder.Create(FFolders);
  //FOUTBOX := TMAPIFolder.Create(FFolders);
  //FWASTEBOX := TMAPIFolder.Create(FFolders);
  //FSENTBOX := TMAPIFolder.Create(FFolders);
end;

destructor TMAPISession.Destroy;
begin
  if Active then Active := false;
  ClearInterfaces;
  FLogonFlags.Destroy;
  FLogoffFlags.Destroy;
  FFolders.Destroy;
  MAPIFreeBuffer(m_psbFolderEID);
  MAPIUninitialize;
  inherited Destroy;
end;

function TMAPISession.FlushQs: HRESULT;
begin
  Result := m_pSpoolerStat.FlushQueues(FWindow, 0, nil, FLUSH_FLAGS);
end;

function TMAPISession.GetActive: boolean;
begin
  Result := FActive;
end;

function TMAPISession.GetInBox: TMAPIFolder;
begin
  Result := TMAPIFolder(FFolders.Items[ORD(FOLDERS_INBOX)]);
end;

function TMAPISession.GetOutBox: TMAPIFolder;
begin
  Result := TMAPIFolder(FFolders.Items[ORD(FOLDERS_OUTBOX)]);
end;

function TMAPISession.GetSentBox: TMAPIFolder;
begin
  Result := TMAPIFolder(FFolders.Items[ORD(FOLDERS_SENT)]);
end;

function TMAPISession.GetSpoolerStatus: HRESULT;
type
  _SPropTagArray_sptCols = packed record
    cValues: ULONG;
    aulPropTag: array[0..1] of ULONG;
  end;
var
  pTbl      : IMAPITable;
  pStat     : IMAPIStatus;
  pRow      : LPSRowSet;
  hRes      : HRESULT;
  sres      : SRestriction;
  spv       : SPropValue;
  ulObjType : ULONG;
  sptCols   : _SPropTagArray_sptCols;
  qq        : SPropValue;
begin
  hRes := S_OK;
  try
    sptCols.cValues := 2;
    sptCols.aulPropTag[0] := PROP_TAG(PT_LONG,      $3E03); //PR_RESOURCE_TYPE
    sptCols.aulPropTag[1] := PROP_TAG(PT_BINARY,    $0FFF); //PR_ENTRYID
    hRes := m_pSess.GetStatusTable(0, @pTbl);
    if ( not FAILED(hRes) ) then
    begin
      sres.rt := RES_PROPERTY;
      sres.resProperty.relop     := RELOP_EQ;
      sres.resProperty.ulPropTag := PROP_TAG(PT_LONG,      $3E03); //PR_RESOURCE_TYPE
      sres.resProperty.lpProp    := @spv;
      spv.ulPropTag := PROP_TAG(PT_LONG,      $3E03); //PR_RESOURCE_TYPE
      spv.Value.l   := MAPI_SPOOLER;
      hRes := HrQueryAllRows( pTbl,
                              LPSPropTagArray(@sptCols),
                              @sres,
                              nil,
                              0,
                              @pRow);
      if ( not FAILED(hRes) ) then
      begin
        qq := LPSPropValue(pChar(pRow.aRow[0].lpProps) + SizeOf(SPropValue))^;
        if not ( (pRow.cRows <> 0) and (PROP_TAG(PT_BINARY,    $0FFF) {PR_ENTRYID} = qq.ulPropTag) ) then
        begin
          hRes := MAKE_MAPI_E($102);  //MAPI_E_NOT_FOUND;
          Result := hRes;
          Exit;
        end;
        hRes := m_pSess.OpenEntry(  qq.Value.bin.cb,
                                    LPENTRYID(qq.Value.bin.lpb),
                                    @IID_IMAPIStatus,
                                    MAPI_BEST_ACCESS,
                                    @ulObjType,
                                    LPUNKNOWN(@pStat));
        if (FAILED(hRes) or (MAPI_STATUS <> ulObjType)) then
        begin
          if not FAILED(hRes) then
            hRes := MAKE_MAPI_E( $108 );   //MAPI_E_INVALID_OBJECT
          Result := hRes;
          Exit;
        end;
        m_pSpoolerStat := pStat;
      end;
    end;
  finally
    FreeProws(pRow);
    if pStat <> nil then
        pStat := nil;
    if pTbl <> nil then
        pTbl := nil;
    Result := hRes;
  end;
end;

function TMAPISession.GetWastBox: TMAPIFolder;
begin
  Result := TMAPIFolder(FFolders.Items[ORD(FOLDERS_WASTE)]);
end;

procedure TMAPISession.Loaded;
begin
  inherited Loaded;
  if FStreamedActive then Active := true;
end;

procedure TMAPISession.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
end;

function TMAPISession.Open: boolean;
var
  hr: HRESULT;
begin
  ClearInterfaces;
  hr := MAPILogonEx(  FWindow,
                      pChar(FProfileName),
                      pChar(FPassword),
                      FLogonFlags.LogonFlag,
                      @m_pSess);
  Result := not FAILED(hr);
  if Result then
  begin
    hr := OpenDefStore;
    Result := not FAILED(hr);
    if not Result then
      Exit;
    hr := m_pSess.OpenAddressBook(FWindow, nil, 0, @m_pAddrBook);
    Result := not FAILED(hr);
    if not Result then
      Exit;
    hr := OpenIPMSubtree;
    Result := not FAILED(hr);
    if not Result then
      Exit;
    hr := GetSpoolerStatus;
    Result := not FAILED(hr);
    if not Result then
      Exit;
  end;
end;

function TMAPISession.OpenDefStore: HRESULT;
type
  _SPropTagArray_sptCols = packed record
    cValues: ULONG;
    aulPropTag: array[0..1] of ULONG;
  end;
var
  pStoresTbl  : IMAPITable;
  pRow        : LPSRowSet;
  sbEID       : SBinary;
  sres        : SRestriction;
  spv         : SPropValue;
  hRes        : HRESULT;
  sptCols     : _SPropTagArray_sptCols;
begin

  hRes := S_OK;

  try

    sptCols.cValues := 2;
    sptCols.aulPropTag[0] := PROP_TAG(PT_BINARY,    $0FFF); //PR_ENTRYID
    sptCols.aulPropTag[1] := PROP_TAG(PT_BOOLEAN,   $3400); //PR_DEFAULT_STORE

    pStoresTbl := nil;
    hRes := m_pSess.GetMsgStoresTable(FWindow, @pStoresTbl);
    if not FAILED(hRes) then
    begin
      sres.rt := RES_PROPERTY;
      sres.resProperty.relop := RELOP_EQ;
      sres.resProperty.ulPropTag := PROP_TAG(PT_BOOLEAN,   $3400); //PR_DEFAULT_STORE
      sres.resProperty.lpProp := @spv;

      spv.ulPropTag := PROP_TAG(PT_BOOLEAN,   $3400); //PR_DEFAULT_STORE
      spv.Value.b   := 1;

      pRow := nil;
      hRes := HrQueryAllRows( pStoresTbl,
                              LPSPropTagArray(@sptCols),
                              @sres,
                              nil,
                              0,
                              @pRow);
      if not FAILED(hRes) then
      begin
        if (  (pRow <> nil) and
              (pRow.cRows <> 0) and
              (pRow.aRow[0].cValues <> 0) and
              (PROP_TAG(PT_BINARY,    $0FFF) = pRow.aRow[0].lpProps.ulPropTag)
        ) then
          sbEID := pRow.aRow[0].lpProps.Value.bin
        else
          hRes := MAKE_MAPI_E($102);  //MAPI_E_NOT_FOUND;
        if not FAILED(hRes) then
        begin
          m_pSess.OpenMsgStore( FWindow,
                                sbEID.cb,
                                LPENTRYID(sbEID.lpb),
                                nil,
                                MDB_WRITE,
                                @m_pMDB);
        end;
      end;
    end;
  finally
    FreeProws(pRow);
    if pStoresTbl <> nil then
        pStoresTbl := nil;
    Result := hRes;
  end;
end;

function TMAPISession.OpenIPMSubtree: HRESULT;
type
  _SPropTagArray_sptFldrs = packed record
    cValues: ULONG;
    aulPropTag: array[0..ORD(FOLDERS_NUM_FOLDERS) - 1] of ULONG;
  end;
var
  pProps                : LPSPropValue;
  hRes                  : HRESULT;
  cProps, ulObjType     : ULONG;
  sbInboxEID            : SBinary;
  qq                    : LPSBinary;
  pp                    : LPSPropValue;
  i                     : Integer;
  sptFldrs              : _SPropTagArray_sptFldrs;
begin
  hRes := S_OK;
  try
    sptFldrs.cValues := ORD(FOLDERS_NUM_FOLDERS);
    sptFldrs.aulPropTag[0] := PROP_TAG( PT_NULL,      PROP_ID_NULL);  //PR_NULL
    sptFldrs.aulPropTag[1] := PROP_TAG( PT_BINARY,    $35E2);         //PR_IPM_OUTBOX_ENTRYID
    sptFldrs.aulPropTag[2] := PROP_TAG( PT_BINARY,    $35E3);         //PR_IPM_WASTEBASKET_ENTRYID
    sptFldrs.aulPropTag[3] := PROP_TAG( PT_BINARY,    $35E4);         //PR_IPM_SENTMAIL_ENTRYID
    sptFldrs.aulPropTag[4] := PROP_TAG( PT_BINARY,    $35E0);         //PR_IPM_SUBTREE_ENTRYID
    pProps := nil;
    cProps := 0;
    hRes := m_pMDB.GetProps(  LPSPropTagArray(@sptFldrs),
                              0,
                              @cProps,
                              @pProps);
    if not FAILED(hRes) then
    begin
      sbInboxEID.cb := 0;
      sbInboxEID.lpb := nil;
      hRes := m_pMDB.GetReceiveFolder( pChar('IPM.Note'),
                                       0,
                                       @sbInboxEID.cb,
                                       LPPENTRYID(@sbInboxEID.lpb),
                                       nil);
      if not FAILED(hRes) then
      begin
        for i := ORD(FOLDERS_INBOX) to ORD(FOLDERS_NUM_FOLDERS) - 1 do
        begin
          pp := LPSPropValue(pChar(pProps) + SizeOf(SPropValue) * i);
          if (pp.ulPropTag <> sptFldrs.aulPropTag[i]) then
          begin
            hRes := MAKE_MAPI_E($102);  //MAPI_E_NOT_FOUND;
            Result := hRes;
            exit;
          end;
          // copy the folder's entry ID to class member
          qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * i);
          if i = ORD(FOLDERS_INBOX) then
            hRes := CopySBinary(  qq,          //@m_psbFolderEID[i]
                                  @sbInboxEID,
                                  Pointer(m_psbFolderEID))
          else
            hRes := CopySBinary(  qq,          //@m_psbFolderEID[i]
                                  @pp.Value.bin,
                                  Pointer(m_psbFolderEID));
          if FAILED(hRes) then
          begin
            Result := hRes;
            exit;
          end;
        end;
        for i := ORD(FOLDERS_INBOX) to ORD(FOLDERS_SENT) do
        begin
          qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * i);
          hRes := m_pSess.OpenEntry(  qq.cb,   //m_psbFolderEID[i].cb,
                                      LPENTRYID(qq.lpb), //LPENTRYID(m_psbFolderEID[i].lpb)
                                      nil,
                                      MAPI_MODIFY,
                                      @ulObjType,
                                      LPUNKNOWN(@m_pFolders[i]));
          if (MAPI_FOLDER <> ulObjType) then
          begin
            hRes := MAKE_MAPI_E( $108 );   //MAPI_E_INVALID_OBJECT
            Result := hRes;
            exit;
          end;
        end;

        qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * ORD(FOLDERS_INBOX));
        INBOX.FolderEID := qq;
        INBOX.IFolder := m_pFolders[ORD(FOLDERS_INBOX)];
        INBOX.DisplayName := 'INBOX';
        INBOX.FolderType := ftInbox;

        qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * ORD(FOLDERS_OUTBOX));
        OUTBOX.FolderEID := qq;
        OUTBOX.IFolder := m_pFolders[ORD(FOLDERS_OUTBOX)];
        OUTBOX.DisplayName := 'OUTBOX';
        OUTBOX.FolderType := ftOutbox;

        qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * ORD(FOLDERS_WASTE));
        WASTEBOX.FolderEID := qq;
        WASTEBOX.IFolder := m_pFolders[ORD(FOLDERS_WASTE)];
        WASTEBOX.DisplayName := 'WASTEBOX';
        WASTEBOX.FolderType := ftWastebox;

        qq := LPSBinary(pChar(m_psbFolderEID) + SizeOf(SBinary) * ORD(FOLDERS_SENT));
        SENTBOX.FolderEID := qq;
        SENTBOX.IFolder := m_pFolders[ORD(FOLDERS_SENT)];
        SENTBOX.DisplayName := 'SENTBOX';
        SENTBOX.FolderType := ftSentbox;

      end;
    end;
  finally
    MAPIFreeBuffer(pProps);
    MAPIFreeBuffer(sbInboxEID.lpb);
    Result := hRes;
  end;
end;

procedure TMAPISession.SetActive(const Value: boolean);
begin
  if ( csReading in ComponentState ) then
    FStreamedActive := Value
  else begin
    if (not FActive) and Value then
    begin
      FActive := Open;
      if FActive then
      begin
        INBOX.Active := true;
        OUTBOX.Active := true;
        WASTEBOX.Active := true;
        SENTBOX.Active := true;
      end;
    end;
    if FActive and (not Value) then
      FActive := Close;
  end;
end;

function TMAPISession.SimpleSend(DisplayNameRecip, sSUBJ, sBODY: String; Attachments: TStrings): HRESULT;
var
  iMes: IMAPIMessage;
  pspvSaved: array[0..1] of SPropValue;
  pAdrList: LPADRLIST;
  eidMsg: ENTRYLIST;
  pspvEID: LPSPropValue;
  qq: LPSPropValue;
  i: Integer;
  pStrmDest, pStrmSrc: IStream;
  ulAttNum: ULONG;
  pAtt: IAttach;
  StatInfo: STATSTG;
  spvAttach: array[0..2] of SPropValue;
  hr: HRESULT;
begin
  Result := m_pFolders[ORD(FOLDERS_OUTBOX)].CreateMessage(nil, 0, @iMes);
  if not FAILED(Result) then
  begin

    pspvSaved[0].ulPropTag := PROP_TAG(PT_TSTRING,   $0037);    //PR_SUBJECT;
    pspvSaved[0].Value.lpszA := pChar(sSUBJ);

    pspvSaved[1].ulPropTag := PROP_TAG(PT_TSTRING,   $1000);    //PR_BODY;
    pspvSaved[1].Value.lpszA := pChar(sBODY);

    //pspvSaved[2].ulPropTag := PROP_TAG(PT_LONG,      $0E07);    //PR_MESSAGE_FLAGS;
    //pspvSaved[2].Value.l := MSGFLAG_UNSENT or MSGFLAG_READ;     //MSGFLAG_SUBMIT | MSGFLAG_READ;

    Result := iMes.SetProps(2, @pspvSaved, nil);
    if not FAILED(Result) then
    begin
      pAdrList := nil;
      MAPIAllocateBuffer(SizeOf(ADRLIST), @pAdrList);
      MAPIAllocateBuffer(SizeOf(SPropValue) * 2, @pAdrList.aEntries[0].rgPropVals);
      pAdrList.cEntries := 1;
      pAdrList.aEntries[0].cValues := 2;
      pAdrList.aEntries[0].rgPropVals.ulPropTag := PROP_TAG(PT_TSTRING,   $3001); //PR_DISPLAY_NAME
      pAdrList.aEntries[0].rgPropVals.Value.lpszA := pChar(DisplayNameRecip);
      qq := LPSPropValue(pChar(pAdrList.aEntries[0].rgPropVals) + SizeOf(SPropValue));
      qq.ulPropTag := PROP_TAG( PT_LONG,      $0C15); //PR_RECIPIENT_TYPE
      qq.Value.l := MAPI_TO;
      Result := m_pAddrBook.ResolveName(0, 0, nil, pAdrList);
      //Result := m_pAddrBook.ResolveName(FWindow, MAPI_DIALOG, nil, pAdrList);
      //if Result = MAKE_MAPI_E( $700 ) then
      //  beep;
      //if Result = MAKE_MAPI_E( $10F ) then
      //  beep;
      if not FAILED(Result) then
      begin
        Result := iMes.ModifyRecipients(0, pAdrList);
        if not FAILED(Result) then
        begin
          Result := iMes.SaveChanges(KEEP_OPEN_READWRITE);
          if not FAILED(Result) then
          begin
            if Assigned(Attachments) and Attachments.InheritsFrom(TStrings) then
            begin
              for i := 0 to Attachments.Count - 1 do
              begin
                //Routine attachment
                pStrmSrc := nil;
                hr := OpenStreamOnFile( @MAPIAllocateBuffer,
                                        @MAPIFreeBuffer,
                                        0,
                                        pChar(Attachments.Strings[i]),
                                        nil,
                                        @pStrmSrc);
                if not FAILED(hr) then
                begin
                  pAtt := nil;
                  hr := iMes.CreateAttach(nil, 0, @ulAttNum, @pAtt);
                  if not FAILED(hr) then
                  begin
                    pStrmDest := nil;
                    hr := pAtt.OpenProperty(  PROP_TAG(PT_BINARY,    $3701), //PR_ATTACH_DATA_BIN
                                              @IID_IStream,
                                              0,
                                              MAPI_MODIFY or MAPI_CREATE,
                                              LPUNKNOWN(@pStrmDest));
                    if not FAILED(hr) then
                    begin
                      pStrmSrc.Stat(@StatInfo, 1 {STATFLAG_NONAME});
                      hr := pStrmSrc.CopyTo(  pStrmDest,
                                              StatInfo.cbSize,
                                              nil,
                                              nil);
                      if not FAILED(hr) then
                      begin
                        spvAttach[0].ulPropTag := PROP_TAG( PT_TSTRING,   $3704); //PR_ATTACH_FILENAME;
                        spvAttach[0].Value.lpszA := pChar(Attachments.Strings[i]);

                        spvAttach[1].ulPropTag := PROP_TAG( PT_LONG,      $3705);  //PR_ATTACH_METHOD;
                        spvAttach[1].Value.l := ATTACH_BY_VALUE;

                        spvAttach[2].ulPropTag := PROP_TAG( PT_LONG,      $370B); //PR_RENDERING_POSITION;
                        spvAttach[2].Value.l := -1;

                        hr := pAtt.SetProps(3, @spvAttach, nil);
                        if not FAILED(hr) then
                          pAtt.SaveChanges(0);
                      end;
                    end;
                    pStrmDest := nil;
                  end;
                  pAtt := nil;
                end;
                pStrmSrc := nil;
                //
              end;
            end;
            Result := iMes.SubmitMessage(0);
            if not FAILED(Result) then
              Result := m_pSpoolerStat.FlushQueues(FWindow, 0, nil, FLUSH_FLAGS);
          end;
        end;
      end;
      FreePadrlist(pAdrList);
    end;
  end;
  //Delete Submited message
  pspvEID := nil;
  HrGetOneProp(iMes, PROP_TAG(PT_BINARY, $0FFF), @pspvEID);
  eidMsg.cValues := 1;
  eidMsg.lpbin   := @pspvEID.Value.bin;
  iMes := nil;
  m_pFolders[ORD(FOLDERS_OUTBOX)].DeleteMessages( @eidMsg,
                                                  FWindow,
                                                  nil,
                                                  MESSAGE_DIALOG);
  //
  //if FAILED(Result) then OleCheck(Result);
end;

{ TMAPILogoffFlags }

constructor TMAPILogoffFlags.Create;
begin
  inherited Create;
  FLOGOFF_SHARED := false;
  FLOGOFF_UI := false;
end;

function TMAPILogoffFlags.GetLogoffFlag: ULONG;
begin
  Result := 0;
  if FLOGOFF_SHARED             then Result := Result or MAPI_LOGOFF_SHARED         ;
  if FLOGOFF_UI                 then Result := Result or MAPI_LOGOFF_UI             ;
end;

{ TMessageFlags }

constructor TMessageFlags.Create;
begin
  inherited Create;
  FREAD            := false;
  FUNMODIFIED      := false;
  FSUBMIT          := false;
  FUNSENT          := false;
  FHASATTACH       := false;
  FFROMME          := false;
  FASSOCIATED      := false;
  FRESEND          := false;
  FRN_PENDING      := false;
  FNRN_PENDING     := false;
end;

function TMessageFlags.GetMessageFlag: ULONG;
begin
  Result := 0;
  if FREAD         then Result := Result or MSGFLAG_READ       ;
  if FUNMODIFIED   then Result := Result or MSGFLAG_UNMODIFIED ;
  if FSUBMIT       then Result := Result or MSGFLAG_SUBMIT     ;
  if FUNSENT       then Result := Result or MSGFLAG_UNSENT     ;
  if FHASATTACH    then Result := Result or MSGFLAG_HASATTACH  ;
  if FFROMME       then Result := Result or MSGFLAG_FROMME     ;
  if FASSOCIATED   then Result := Result or MSGFLAG_ASSOCIATED ;
  if FRESEND       then Result := Result or MSGFLAG_RESEND     ;
  if FRN_PENDING   then Result := Result or MSGFLAG_RN_PENDING ;
  if FNRN_PENDING  then Result := Result or MSGFLAG_NRN_PENDING;
end;

procedure TMessageFlags.SetMessageFlag(const Value: ULONG);
begin
  FREAD         := false;
  FUNMODIFIED   := false;
  FSUBMIT       := false;
  FUNSENT       := false;
  FHASATTACH    := false;
  FFROMME       := false;
  FASSOCIATED   := false;
  FRESEND       := false;
  FRN_PENDING   := false;
  FNRN_PENDING  := false;
  if (Value and MSGFLAG_READ       ) = MSGFLAG_READ         then FREAD         := true;
  if (Value and MSGFLAG_UNMODIFIED ) = MSGFLAG_UNMODIFIED   then FUNMODIFIED   := true;
  if (Value and MSGFLAG_SUBMIT     ) = MSGFLAG_SUBMIT       then FSUBMIT       := true;
  if (Value and MSGFLAG_UNSENT     ) = MSGFLAG_UNSENT       then FUNSENT       := true;
  if (Value and MSGFLAG_HASATTACH  ) = MSGFLAG_HASATTACH    then FHASATTACH    := true;
  if (Value and MSGFLAG_FROMME     ) = MSGFLAG_FROMME       then FFROMME       := true;
  if (Value and MSGFLAG_ASSOCIATED ) = MSGFLAG_ASSOCIATED   then FASSOCIATED   := true;
  if (Value and MSGFLAG_RESEND     ) = MSGFLAG_RESEND       then FRESEND       := true;
  if (Value and MSGFLAG_RN_PENDING ) = MSGFLAG_RN_PENDING   then FRN_PENDING   := true;
  if (Value and MSGFLAG_NRN_PENDING) = MSGFLAG_NRN_PENDING  then FNRN_PENDING  := true;
end;

{ TMAPIMessage }

constructor TMAPIMessage.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FIMessage := nil;
  FMessageFlags := TMessageFlags.Create;
  FAttachments := TMAPIAttachments.Create(self, TMAPIAttachment);
  FRecipients := TMAPIRecipients.Create(self, TMAPIRecipient);;
  FMessageID := nil;
  MAPIAllocateBuffer(SizeOf(SBinary), @FMessageID);
end;

destructor TMAPIMessage.Destroy;
begin
  FAttachments.Destroy;
  FMessageFlags.Destroy;
  FRecipients.Destroy;
  FIMessage := nil;
  MAPIFreeBuffer(FMessageID);
  inherited Destroy;
end;

function TMAPIMessage.GetBody: String;
var
  pStream : IStream;
  StatInfo : STATSTG;
  hr : HRESULT;
  pBody : PChar;
  sBody : string;
begin
  //PR_BODY
  hr := FIMessage.OpenProperty(PROP_TAG(PT_TSTRING,$1000), @IID_IStream,
                         0, 0, LPUNKNOWN(@pStream));
  if not FAILED(hr) then
  begin
    pStream.Stat(@StatInfo, 1 {STATFLAG_NONAME});
    //pBody := nil;
    GetMem(pBody, StatInfo.cbSize);
    hr := pStream.Read(pBody ,StatInfo.cbSize, nil);
    pStream := nil;
    if not FAILED(hr) then
      sBody := pBody
    else
      sBody := '';
    FreeMemory(pBody);
  end;
  Result := sBody;
end;

function TMAPIMessage.GetDisplayName: string;
begin
  Result := 'from ' + REPRESENTING_NAME + ' , subj: ' + SUBJECT;
end;

function TMAPIMessage.GetRTFBody: String;
var
  pStream : IStream;
  pRTFStream : IStream;
  //StatInfo : STATSTG;
  hr : HRESULT;
  pBody : PChar;
  sBody : string;
  iCBRead : Integer;
begin
  pStream := nil;
  hr := FIMessage.OpenProperty(PROP_TAG(PT_BINARY,$1009), @IID_IStream,
                         0, 0, LPUNKNOWN(@pStream));
  if not FAILED(hr) then
  begin
    pRTFStream := nil;
    WrapCompressedRTFStream(pStream, 0, pRTFStream);
    GetMem(pBody, 4100);
    iCBRead := 1;
    sBody := '';
    //stat doesn't work on returned RTF stream
    while iCBRead > 0 do
    begin
      ZeroMemory(pBody, 4100);
      pRTFStream.Read(pBody, 4095, @iCBRead);
      sBody := sBody + pBody;
    end;
    FreeMemory(pBody);
    pRTFStream := nil;
    pStream := nil;
  end;

  Result := sBody;
end;

function TMAPIMessage.IsEqual(Value: TMAPIMessage): Boolean;
begin
  Result := false;
end;

procedure TMAPIMessage.SetAttachList(const Value: TMAPIAttachments);
begin
  FAttachments.Assign(Value);
end;

function TMAPIMessage.SetRead(Read: Boolean): Boolean;
var
  Flags : Integer;
  hr : HRESULT;
begin
  if not Read then
    Flags := CLEAR_READ_FLAG
  else
    Flags := 0;
  hr := FIMessage.SetReadFlag(Flags);
  Result := not FAILED(hr)
end;

{ TMAPIFolder }

function TMAPIFolder.Close: boolean;
begin
  Result := false;
  FreeMessageList;
  FreeFolderList;
end;

constructor TMAPIFolder.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FFolders := TMAPIFolders.Create(self, TMAPIFolder);
  FMAPISession := TMAPIFolders(Collection).FMAPISession;
  FFolders.FMAPISession := FMAPISession;
  FMessages := TMAPIMessages.Create(self, TMAPIMessage);
  FMessages.FMAPISession := FMAPISession;
  FFolderType := ftInbox;
  FIFolder := nil;
  FFolderEID := nil;
  MAPIAllocateBuffer(SizeOf(SBinary), @FFolderEID);
end;

destructor TMAPIFolder.Destroy;
begin
  if Active then Active := false;
  FIFolder := nil;
  MAPIFreeBuffer(FFolderEID);
  FFolders.Destroy;
  FMessages.Destroy;
  inherited Destroy;
end;

function TMAPIFolder.GetActive: boolean;
begin
  Result := FActive;
end;

function TMAPIFolder.GetFoldersCount: Integer;
begin
  Result := FFolders.Count;
end;

function TMAPIFolder.GetMAPIFolder(Index: Integer): TMAPIFolder;
begin
  Result := TMAPIFolder(FFolders.Items[Index]);
end;

function TMAPIFolder.GetMAPIMessage(Index: Integer): TMAPIMessage;
begin
  Result := TMAPIMessage(FMessages.Items[Index]);
end;

function TMAPIFolder.GetMessagesCount: Integer;
begin
  Result := FMessages.Count;
end;

function TMAPIFolder.Open: boolean;
begin
  Result := true;
  if FMAPISession <> nil then
  begin
    if FMAPISession.Active then
    begin
      if FIFolder <> nil then
      begin
        if FFolderEID <> nil then
        begin
          FreeMessageList;
          FreeFolderList;
          GetFolderList;
          GetMessageList;
        end else
          Result := false;
      end else
        Result := false;
    end else
      Result := false;
  end else
    Result := false;
end;

procedure TMAPIFolder.SetActive(const Value: boolean);
begin
  if (not FActive) and Value then
    FActive := Open;
  if FActive and (not Value) then
    FActive := Close;
end;

procedure TMAPIFolder.FreeMessageList;
var
  oMess: TMAPIMessage;
begin
  if FMessages.Count <> 0 then
  begin
    while FMessages.Count <> 0 do
    begin
      oMess := TMAPIMessage(FMessages.Items[0]);
      oMess.Destroy;
    end;
    FMessages.Clear;
  end;
end;

procedure TMAPIFolder.FreeFolderList;
var
  oFold: TMAPIFolder;
begin
  if FFolders.Count <> 0 then
  begin
    while FFolders.Count > 0 do
    begin
      oFold := TMAPIFolder(FFolders.Items[0]);
      oFold.Destroy;
    end;
    FFolders.Clear;
  end;
end;

procedure TMAPIFolder.GetFolderList;
type
  _SPropTagArray_sptCols = packed record
    cValues: ULONG;
    aulPropTag: array[0..4] of ULONG;
  end;
var
  pCTbl: IMAPITable;
  pRows: LPSRowSet;
  sptCols: _SPropTagArray_sptCols;
  i: Integer;
  oFolder: TMAPIFolder;
  qq: LPSPropValue;
  ulObjType: ULONG;
begin
  pCTbl := nil;
  pRows := nil;
  sptCols.cValues := 5;
  sptCols.aulPropTag[0] := PROP_TAG( PT_TSTRING,   $3001);  //PR_DISPLAY_NAME
  sptCols.aulPropTag[1] := PROP_TAG( PT_TSTRING,   $0037);  //PR_SUBJECT
  sptCols.aulPropTag[2] := PROP_TAG( PT_BINARY,    $0FFF);  //PR_ENTRYID
  sptCols.aulPropTag[3] := PROP_TAG( PT_LONG,      $3601);  //PR_FOLDER_TYPE
  sptCols.aulPropTag[4] := PROP_TAG( PT_TSTRING,   $3004);  //PR_COMMENT
  try
    FIFolder.GetHierarchyTable(0, @pCTbl);
    HrQueryAllRows( pCTbl,
                    LPSPropTagArray(@sptCols),
                    nil,
                    nil,
                    0,
                    @pRows);
    for i := 0 to pRows.cRows - 1 do
    begin
      qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 2);
      if (PROP_TAG(PT_BINARY, $0FFF) = qq.ulPropTag) then         //PR_ENTRYID
      begin
        oFolder := TMAPIFolder(FFolders.Add);
        CopySBinary(  oFolder.FolderEID,
                      @qq.Value.bin,
                      oFolder.FolderEID);
        MAPISession.MAPISession.OpenEntry(  oFolder.FolderEID.cb,   //m_psbFolderEID[i].cb,
                                            LPENTRYID(oFolder.FolderEID.lpb), //LPENTRYID(m_psbFolderEID[i].lpb)
                                            nil,
                                            MAPI_MODIFY,
                                            @ulObjType,
                                            LPUNKNOWN(@oFolder.FIFolder));
        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps));
        if (PROP_TAG( PT_TSTRING, $3001) = qq.ulPropTag) then      //PR_DISPLAY_NAME
          oFolder.DisplayName := qq.Value.lpszA
        else
          oFolder.DisplayName := '';
        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 1);
        if (PROP_TAG( PT_TSTRING,   $0037) = qq.ulPropTag) then      //PR_SUBJECT
          oFolder.SUBJECT := qq.Value.lpszA
        else
          oFolder.SUBJECT := '';
        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 4);
        if (PROP_TAG( PT_TSTRING,   $3004) = qq.ulPropTag) then      //PR_COMMENT
          oFolder.SUBJECT := qq.Value.lpszA
        else
          oFolder.SUBJECT := '';

      end;
    end;
  finally
    FreeProws(pRows);
    pCTbl := nil;
  end;
end;

procedure TMAPIFolder.GetMessageList;
type
  _SPropTagArray_sptCols = packed record
    cValues: ULONG;
    aulPropTag: array[0..6] of ULONG;
  end;
  _SPropTagArray_sptColsAtt = packed record
    cValues: ULONG;
    aulPropTag: array[0..4] of ULONG;
  end;
var
  pCTbl: IMAPITable;
  pAttRows, pRows: LPSRowSet;
  sptCols: _SPropTagArray_sptCols;
  sptColsAtt: _SPropTagArray_sptColsAtt;
  i, j: Integer;
  k, l: ULONG;
  oMes: TMAPIMessage;
  qq, qq1: LPSPropValue;
  ulObjType: ULONG;
  AttachTable: IMAPITable;
  IAtt: IAttach;
begin
  pCTbl := nil;
  pRows := nil;
  sptCols.cValues := 7;
  sptCols.aulPropTag[0] := PROP_TAG( PT_TSTRING,   $0042);  //PR_SENT_REPRESENTING_NAME
  sptCols.aulPropTag[1] := PROP_TAG( PT_TSTRING,   $0037);  //PR_SUBJECT
  sptCols.aulPropTag[2] := PROP_TAG( PT_BINARY,    $0FFF);  //PR_ENTRYID
  sptCols.aulPropTag[3] := PROP_TAG( PT_LONG,      $0E07);  //PR_MESSAGE_FLAGS
  sptCols.aulPropTag[4] := PROP_TAG( PT_TSTRING,   $1000);  //PR_BODY;
  sptCols.aulPropTag[5] := PROP_TAG( PT_LONG,      $0E08);  //PR_MESSAGE_SIZE
  sptCols.aulPropTag[6] := PROP_TAG( PT_SYSTIME,   $0E06);  //PR_MESSAGE_DELIVERY_TIME

  try
    FIFolder.GetContentsTable(0, @pCTbl);
    HrQueryAllRows( pCTbl,
                    LPSPropTagArray(@sptCols),
                    nil,
                    nil,
                    0,
                    @pRows);
    for i := 0 to pRows.cRows - 1 do
    begin
      qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 2);
      if (PROP_TAG(PT_BINARY, $0FFF) = qq.ulPropTag) then         //PR_ENTRYID
      begin

        ////
        ////    Redo
        ////
        //oMes := TMAPIMessage.Create(nil);
        oMes := TMAPIMessage(FMessages.Add);
        ////
        ////

        oMes.FMAPISession := self.MAPISession;
        CopySBinary(  oMes.MessageID,
                      @qq.Value.bin,
                      oMes.MessageID);
        MAPISession.MAPISession.OpenEntry(  oMes.MessageID.cb,
                                            LPENTRYID(oMes.MessageID.lpb),
                                            nil,
                                            MAPI_MODIFY,
                                            @ulObjType,
                                            LPUNKNOWN(@oMes.FIMessage));

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps));
        if (PROP_TAG(PT_TSTRING, $0042) = qq.ulPropTag) then      //PR_SENT_REPRESENTING_NAME
            oMes.FREPRESENTING_NAME := qq.Value.lpszA
        else
            oMes.FREPRESENTING_NAME := '<no sender>';

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 1);
        if (PROP_TAG( PT_TSTRING,   $0037) = qq.ulPropTag) then   //PR_SUBJECT
            oMes.FSUBJECT := qq.Value.lpszA
        else
            oMes.FSUBJECT := '<no subject>';

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 4);
        if (PROP_TAG(PT_TSTRING,   $1000) = qq.ulPropTag) then    //PR_BODY;
            oMes.FBODY := qq.Value.lpszA
        else
            oMes.FBODY := '';

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 3);
        if (PROP_TAG(PT_LONG, $0E07) = qq.ulPropTag) then         //PR_MESSAGE_FLAGS
          oMes.MessageFlags.MessageFlag := qq.Value.l
        else
          oMes.MessageFlags.MessageFlag := 0;

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 5);
        if (PROP_TAG(PT_LONG, $0E08) = qq.ulPropTag) then         //PR_MESSAGE_SIZE
          oMes.FSize := qq.Value.l
        else
          oMes.FSize := 0;

        qq := LPSPropValue(pChar(pRows.aRow[i].lpProps) + SizeOf(SPropValue) * 6);
        if (PROP_TAG(PT_SYSTIME, $0E06) = qq.ulPropTag) then         //PR_MESSAGE_DELIVERY_TIME
          oMes.FMessageDeliveryTime := FileTimeToDateTime(qq.Value.ft)
        else
          oMes.FMessageDeliveryTime := 0;

        if oMes.MessageFlags.HASATTACH then
        begin
          //Add attachments to a message
          try
            AttachTable := nil;
            oMes.FIMessage.GetAttachmentTable(0, @AttachTable);
            sptColsAtt.cValues := 5;
            sptColsAtt.aulPropTag[0] := PROP_TAG(PT_LONG, $0E21);     //PR_ATTACH_NUM
            sptColsAtt.aulPropTag[1] := PROP_TAG(PT_TSTRING, $3704);  //PR_ATTACH_FILENAME
            sptColsAtt.aulPropTag[2] := PROP_TAG(PT_TSTRING, $3703);  //PR_ATTACH_EXTENSION
            sptColsAtt.aulPropTag[3] := PROP_TAG(PT_LONG, $3705);     //PR_ATTACH_METHOD
            sptColsAtt.aulPropTag[4] := PROP_TAG(PT_TSTRING, $3708);  //PR_ATTACH_PATHNAME
            AttachTable.SetColumns(LPSPropTagArray(@sptColsAtt), 0);
            AttachTable.GetRowCount(0, @k);
            for j := 0 to k - 1 do
            begin
              try
                pAttRows := nil;
                AttachTable.QueryRows(1, 0, @pAttRows);
                if pAttRows.aRow[0].lpProps.ulPropTag = PROP_TAG(PT_LONG, $0E21) then //PR_ATTACH_NUM
                begin
                  l := pAttRows.aRow[0].lpProps.Value.l;
                  IAtt := nil;
                  oMes.FIMessage.OpenAttach(l, nil, 0, @IAtt);
                  qq1 := LPSPropValue(pChar(pAttRows.aRow[0].lpProps) + SizeOf(SPropValue) * 1);  ////PR_ATTACH_FILENAME
                  if ( not FAILED(qq1.Value.err) ) then
                    oMes.Attachments.CreateAttach(ExtractFileName(qq1.Value.lpszA), qq1.Value.lpszA, l, IAtt);
                  //    Fix this later ...
                  //else
                  //  oMes.Attachments.CreateAttach('Untitled', 'Untitled.tmp', l, IAtt);
                end;
              finally
                FreeProws(pAttRows);
                IAtt := nil;
              end;
            end;
          finally
            AttachTable := nil;
          end;
        end;



      end;
    end;
  finally
    FreeProws(pRows);
    pCTbl := nil;
  end;
end;

procedure TMAPIFolder.AssignFolder(Fold: TMAPIFolder);
begin
  //
end;

procedure TMAPIFolder.Assign(Source: TPersistent);
begin
  if Source is TMAPIFolder then
    AssignFolder(TMAPIFolder(Source))
//  else if Source is {} then
  else
    inherited Assign(Source);
end;

function TMAPIFolder.IsEqual(Value: TMAPIFolder): Boolean;
begin
  Result := false;
end;

procedure TMAPIFolder.SetFolderEID(const Value: LPSBinary);
begin
  if Assigned(FFolderEID) then
    MAPIFreeBuffer(FFolderEID);
  FFolderEID := nil;
  MAPIAllocateBuffer(SizeOf(SBinary), @FFolderEID);
  CopySBinary(  FFolderEID,
                Value,
                Pointer(FFolderEID));
end;

function TMAPIFolder.GetDisplayName: string;
begin
  Result := DisplayName;
end;

function TMAPIFolder.DeleteMessage(Index: Integer): Boolean;
var
  Mails : SBinaryArray;
  hr : HRESULT;
begin
  Mails.cValues := 1;
  Mails.lpbin := TMAPIMessage(FMessages.Items[Index]).MessageID;
  hr := FIFolder.DeleteMessages(LPENTRYLIST(@Mails), 0,nil, 0);
  Result := not FAILED(hr);
end;

function TMAPIFolder.DeleteToWaste(Index: Integer): Boolean;
var
  Mails : SBinaryArray;
  hr : HRESULT;
begin
  Mails.cValues := 1;
  Mails.lpbin := TMAPIMessage(FMessages.Items[Index]).MessageID;
  hr := FIFolder.CopyMessages(
      LPENTRYLIST(@Mails), @IID_IMAPIFolder,
pPointer(FMAPISession.m_pFolders[ORD(FOLDERS_WASTE)]),
      0, nil, MESSAGE_MOVE);

  //FIFolder.DeleteMessages(LPENTRYLIST(@Mails), 0,nil, 0);
  Result := not FAILED(hr);
end;

{ TMAPIAttachments }

procedure TMAPIAttachments.AssignValues(Value: TMAPIAttachments);
var
  I: Integer;
  P: TMAPIAttachment;
begin
  for I := 0 to Value.Count - 1 do
  begin
    P := FindAttach(Value[I].Name);
    if P <> nil then
      P.Assign(Value[I]);
  end;
end;

function TMAPIAttachments.CreateAttach(AttName, AttFileName: String; AttNum: Integer; AttInterface: IAttach): TMAPIAttachment;
var
  pStrmDest: IStream;
begin
  Result := Add as TMAPIAttachment;
  Result.FileName := AttFileName;
  Result.Name := AttName;
  Result.FNumber := AttNum;
  Result.FAttach := AttInterface;
  pStrmDest := nil;
  try
    OleCheck(Result.FAttach.OpenProperty(  PROP_TAG(PT_BINARY,    $3701), //PR_ATTACH_DATA_BIN
                                  @IID_IStream,
                                  0,
                                  0,
                                  LPUNKNOWN(@pStrmDest)));
    Result.FStream := TIStream.Create(pStrmDest);
  finally
    pStrmDest := nil;
  end;
end;

function TMAPIAttachments.FindAttach(const Value: string): TMAPIAttachment;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
  begin
    Result := TMAPIAttachment(inherited Items[I]);
    if AnsiCompareText(Result.Name, Value) = 0 then Exit;
  end;
  Result := nil;
end;

{$IFDEF VER130}
function TMAPIAttachments.GetCollectionOwner: TPersistent;
begin
  Result := GetOwner;
end;
{$ENDIF}

function TMAPIAttachments.GetItem(Index: Integer): TMAPIAttachment;
begin
  Result := TMAPIAttachment(inherited Items[Index]);
end;

function TMAPIAttachments.IsEqual(Value: TMAPIAttachments): Boolean;
var
  I: Integer;
begin
  Result := Count = Value.Count;
  if Result then
    for I := 0 to Count - 1 do
    begin
      Result := TMAPIAttachment(Items[I]).IsEqual(TMAPIAttachment(Value.Items[I]));
      if not Result then Break;
    end
end;

procedure TMAPIAttachments.SetItem(Index: Integer;
  const Value: TMAPIAttachment);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

{ TMAPIAttachment }

procedure TMAPIAttachment.Assign(Source: TPersistent);
begin
  if Source is TMAPIAttachment then
    AssignAttach(TMAPIAttachment(Source))
//  else if Source is {} then
  else
    inherited Assign(Source);
end;

procedure TMAPIAttachment.AssignAttach(Attach: TMAPIAttachment);
begin
  if Attach <> nil then
  begin
    Name := Attach.Name;
    FileName := Attach.FileName;
    FNumber := Attach.FNumber;
    FAttach := Attach.FAttach;
    FStream := TIStream.Create(Attach.FStream.IntStream);
  end;
end;

constructor TMAPIAttachment.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FAttachments := TMAPIAttachments(Collection);
  FAttachName := '';
  FFileName := '';
  FStream := nil;
  FNumber := 0;
  FAttach := nil;
end;

destructor TMAPIAttachment.Destroy;
begin
  if Assigned(FStream) then FStream.Destroy;
  FAttach := nil;
  inherited Destroy;
end;

function TMAPIAttachment.GetDisplayName: string;
begin
  if Name <> '' then
    Result := Name
  else
    Result := inherited GetDisplayName;
end;

function TMAPIAttachment.IsEqual(Value: TMAPIAttachment): Boolean;
begin
  Result := (Name = Value.Name) and (FileName = Value.FileName);
end;

{ TMAPIFolders }

procedure TMAPIFolders.AssignValues(Value: TMAPIFolders);
var
  I: Integer;
  P: TMAPIFolder;
begin
  for I := 0 to Value.Count - 1 do
  begin
    P := FindFolder(Value[I].DisplayName);
    if P <> nil then
      P.Assign(Value[I]);
  end;
end;

function TMAPIFolders.CreateFolder: TMAPIFolder;
begin
  Result := Add as TMAPIFolder;
end;

function TMAPIFolders.FindFolder(const Value: string): TMAPIFolder;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
  begin
    Result := TMAPIFolder(inherited Items[I]);
    if AnsiCompareText(Result.DisplayName, Value) = 0 then Exit;
  end;
  Result := nil;
end;

{$IFDEF VER130}
function TMAPIFolders.GetCollectionOwner: TPersistent;
begin
  Result := GetOwner;
end;
{$ENDIF}

function TMAPIFolders.GetItem(Index: Integer): TMAPIFolder;
begin
  Result := TMAPIFolder(inherited Items[Index]);
end;

function TMAPIFolders.IsEqual(Value: TMAPIFolders): Boolean;
var
  I: Integer;
begin
  Result := Count = Value.Count;
  if Result then
    for I := 0 to Count - 1 do
    begin
      Result := TMAPIFolder(Items[I]).IsEqual(TMAPIFolder(Value.Items[I]));
      if not Result then Break;
    end
end;

procedure TMAPIFolders.SetItem(Index: Integer; const Value: TMAPIFolder);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

{ TMAPIMessages }

procedure TMAPIMessages.AssignValues(Value: TMAPIMessages);
var
  I: Integer;
  P: TMAPIMessage;
begin
  for I := 0 to Value.Count - 1 do
  begin
    P := FindMessage(Value[I].REPRESENTING_NAME);
    if P <> nil then
      P.Assign(Value[I]);
  end;
end;

function TMAPIMessages.CreateMessage: TMAPIMessage;
begin
  Result := Add as TMAPIMessage;
  //if TMAPIFolder(Owner).Active then
  //begin
  //  TMAPIFolder(Owner).IFolder.CreateMessage(nil, Result.MessageFlags.MessageFlag, @Result.IMessage);
  //  Result.FMessageID := nil;
  //  HrGetOneProp(Result.IMessage, PROP_TAG(PT_BINARY, $0FFF), @Result.FMessageID);
  //end;
end;

function TMAPIMessages.FindMessage(const Value: string): TMAPIMessage;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
  begin
    Result := TMAPIMessage(inherited Items[I]);
    if AnsiCompareText(Result.REPRESENTING_NAME, Value) = 0 then Exit;
  end;
  Result := nil;
end;

{$IFDEF VER130}
function TMAPIMessages.GetCollectionOwner: TPersistent;
begin
  Result := GetOwner;
end;
{$ENDIF}

function TMAPIMessages.GetItem(Index: Integer): TMAPIMessage;
begin
  Result := TMAPIMessage(inherited Items[Index]);
end;

function TMAPIMessages.IsEqual(Value: TMAPIMessages): Boolean;
var
  I: Integer;
begin
  Result := Count = Value.Count;
  if Result then
    for I := 0 to Count - 1 do
    begin
      Result := TMAPIMessage(Items[I]).IsEqual(TMAPIMessage(Value.Items[I]));
      if not Result then Break;
    end
end;

procedure TMAPIMessages.SetItem(Index: Integer; const Value: TMAPIMessage);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

procedure TMAPIMessages.SetMessagesSubmited(const Value: Boolean);
begin
  if Value then
  begin
    if not FAILED(SubmitMessages) then
      FMessagesSubmited := Value;
  end else
    FMessagesSubmited := Value;
end;

function TMAPIMessages.SubmitMessages: HRESULT;
var
  oMess: TMAPIMessage;
  oFolder: TMAPIFolder;
  //iMes: IMAPIMessage;
  pspvSaved: array[0..1] of SPropValue;
  pAdrList: LPADRLIST;
  //eidMsg: ENTRYLIST;
  //pspvEID: LPSPropValue;
  qq: LPSPropValue;
  i: Integer;
  j: Integer;
  k: Integer;
  pStrmDest, pStrmSrc: IStream;
  //ulAttNum: ULONG;
  //pAtt: IAttach;
  StatInfo: STATSTG;
  spvAttach: array[0..2] of SPropValue;
  hr: HRESULT;
begin

  Result := S_OK;

  oFolder := TMAPIFolder(Owner);
  if oFolder.Active then
  begin

    for j := 0 to Count - 1 do
    begin

      oMess := Items[j];

      if oMess.IMessage = nil then
      begin

        Result := oFolder.IFolder.CreateMessage(nil, oMess.MessageFlags.MessageFlag, @oMess.IMessage);
        if not FAILED(Result) then
        begin

          pspvSaved[0].ulPropTag := PROP_TAG(PT_TSTRING,   $0037);    //PR_SUBJECT;
          pspvSaved[0].Value.lpszA := pChar(oMess.SUBJECT);

          pspvSaved[1].ulPropTag := PROP_TAG(PT_TSTRING,   $1000);    //PR_BODY;
          pspvSaved[1].Value.lpszA := pChar(oMess.BODY);

          //pspvSaved[2].ulPropTag := PROP_TAG(PT_LONG,      $0E07);    //PR_MESSAGE_FLAGS;
          //pspvSaved[2].Value.l := oMess.MessageFlags.MessageFlag;     //MSGFLAG_UNSENT or MSGFLAG_READ;     //MSGFLAG_SUBMIT | MSGFLAG_READ;

          Result := oMess.IMessage.SetProps(2, @pspvSaved, nil);

          if not FAILED(Result) then
          begin

            pAdrList := nil;
            MAPIAllocateBuffer(SizeOf(ADRLIST) + SizeOf(ADRENTRY)*(oMess.Recipients.Count - 1), @pAdrList);
            pAdrList.cEntries := oMess.Recipients.Count;
            for k := 0 to oMess.Recipients.Count - 1 do
            begin
              MAPIAllocateBuffer(SizeOf(SPropValue) * 2, @pAdrList.aEntries[k].rgPropVals);
              pAdrList.aEntries[k].cValues := 2;

              if oMess.Recipients.Items[k].Name <> '' then
              begin
                pAdrList.aEntries[k].rgPropVals.ulPropTag := PROP_TAG(PT_TSTRING,   $3001); //PR_DISPLAY_NAME
                pAdrList.aEntries[k].rgPropVals.Value.lpszA := pChar(oMess.Recipients.Items[k].Name);
              end else if oMess.Recipients.Items[k].EMail <> '' then
              begin
                //pAdrList.aEntries[k].rgPropVals.ulPropTag := PROP_TAG(PT_TSTRING,   $3003); //PR_EMAIL_ADDRESS
                pAdrList.aEntries[k].rgPropVals.ulPropTag := PROP_TAG(PT_TSTRING,   $3001); //PR_DISPLAY_NAME
                pAdrList.aEntries[k].rgPropVals.Value.lpszA := pChar(oMess.Recipients.Items[k].EMail);
              end else begin
              end;
              qq := LPSPropValue(pChar(pAdrList.aEntries[k].rgPropVals) + SizeOf(SPropValue));
              qq.ulPropTag := PROP_TAG( PT_LONG,      $0C15); //PR_RECIPIENT_TYPE
              qq.Value.l := MAPI_TO;
            end;

            MAPISession.m_pAddrBook.ResolveName(0, 0, nil, pAdrList);

            //Result := m_pAddrBook.ResolveName(FWindow, MAPI_DIALOG, nil, pAdrList);
            //if Result = MAKE_MAPI_E( $700 ) then
            //  beep;
            //if Result = MAKE_MAPI_E( $10F ) then
            //  beep;
            //if not FAILED(Result) then
            //begin
              oMess.IMessage.ModifyRecipients(0, pAdrList);
              //if not FAILED(Result) then
              //begin
                Result := oMess.IMessage.SaveChanges(KEEP_OPEN_READWRITE);
                if not FAILED(Result) then
                begin
                  //if Assigned(Attachments) and Attachments.InheritsFrom(TStrings) then
                  if oMess.Attachments.Count > 0 then
                  begin
                    for i := 0 to oMess.Attachments.Count - 1 do
                    begin
                      //Routine attachment
                      pStrmSrc := nil;
                      hr := OpenStreamOnFile( @MAPIAllocateBuffer,
                                              @MAPIFreeBuffer,
                                              0,
                                              pChar(oMess.Attachments.Items[i].FileName),
                                              nil,
                                              @pStrmSrc);
                      if not FAILED(hr) then
                      begin
                        oMess.Attachments.Items[i].FAttach := nil;
                        hr := oMess.IMessage.CreateAttach(  nil, 0,
                                                            @oMess.Attachments.Items[i].FNumber,
                                                            @oMess.Attachments.Items[i].FAttach);
                        if not FAILED(hr) then
                        begin
                          pStrmDest := nil;
                          hr := oMess.Attachments.Items[i].FAttach.OpenProperty(  PROP_TAG(PT_BINARY,    $3701), //PR_ATTACH_DATA_BIN
                                                    @IID_IStream,
                                                    0,
                                                    MAPI_MODIFY or MAPI_CREATE,
                                                    LPUNKNOWN(@pStrmDest));
                          if not FAILED(hr) then
                          begin
                            pStrmSrc.Stat(@StatInfo, 1); //STATFLAG_NONAME
                            hr := pStrmSrc.CopyTo(  pStrmDest,
                                                    StatInfo.cbSize,
                                                    nil,
                                                    nil);
                            if not FAILED(hr) then
                            begin
                              spvAttach[0].ulPropTag := PROP_TAG( PT_TSTRING,   $3704); //PR_ATTACH_FILENAME;
                              spvAttach[0].Value.lpszA := pChar(oMess.Attachments.Items[i].FileName);

                              spvAttach[1].ulPropTag := PROP_TAG( PT_LONG,      $3705);  //PR_ATTACH_METHOD;
                              spvAttach[1].Value.l := ATTACH_BY_VALUE;

                              spvAttach[2].ulPropTag := PROP_TAG( PT_LONG,      $370B); //PR_RENDERING_POSITION;
                              spvAttach[2].Value.l := -1;

                              hr := oMess.Attachments.Items[i].FAttach.SetProps(3, @spvAttach, nil);
                              if not FAILED(hr) then
                                oMess.Attachments.Items[i].FAttach.SaveChanges(0);
                            end;
                          end;
                          pStrmDest := nil;
                        end;
                        //pAtt := nil;
                      end;
                      pStrmSrc := nil;
                      //
                    end;
                  end;
                  Result := oMess.IMessage.SubmitMessage(0);
                  //if not FAILED(Result) then
                  //  Result := m_pSpoolerStat.FlushQueues(FWindow, 0, nil, FLUSH_FLAGS);
                end;
              //end;
            //end;
            FreePadrlist(pAdrList);

          end;
        end;

        //Delete Submited message
        //pspvEID := nil;

        oMess.MessageID := nil;
        HrGetOneProp(oMess.IMessage, PROP_TAG(PT_BINARY, $0FFF), @oMess.MessageID);

        //eidMsg.cValues := 1;
        //eidMsg.lpbin   := @pspvEID.Value.bin;
        //iMes := nil;
        //m_pFolders[ORD(FOLDERS_OUTBOX)].DeleteMessages( @eidMsg,
        //                                                FWindow,
        //                                                nil,
        //                                                MESSAGE_DIALOG);
        //
        //if FAILED(Result) then OleCheck(Result);

      end;

    end;

  end;

end;

{ TMAPIRecipient }

procedure TMAPIRecipient.Assign(Source: TPersistent);
begin
  if Source is TMAPIRecipient then
    AssignRecipient(TMAPIRecipient(Source))
//  else if Source is {} then
  else
    inherited Assign(Source);
end;

procedure TMAPIRecipient.AssignRecipient(Recipient: TMAPIRecipient);
begin
  if Recipient <> nil then
  begin
    Name := Recipient.Name;
    EMail := Recipient.EMail;
  end;
end;

constructor TMAPIRecipient.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FName := '';
  FEMail := '';
end;

destructor TMAPIRecipient.Destroy;
begin
  inherited Destroy;
end;

function TMAPIRecipient.GetDisplayName: string;
begin
  Result := Name;
  if EMail <> '' then
    Result := Result + ' (' + EMail + ')';
end;

function TMAPIRecipient.IsEqual(Value: TMAPIRecipient): Boolean;
begin
  Result := (Name = Value.Name) and (EMail = Value.EMail);
end;

{ TMAPIRecipients }

procedure TMAPIRecipients.AssignValues(Value: TMAPIRecipients);
var
  I: Integer;
  P: TMAPIRecipient;
begin
  for I := 0 to Value.Count - 1 do
  begin
    P := FindRecipient(Value[I].Name);
    if P <> nil then
      P.Assign(Value[I]);
  end;
end;

function TMAPIRecipients.CreateRecipient: TMAPIRecipient;
begin
  Result := Add as TMAPIRecipient;
end;

function TMAPIRecipients.FindRecipient(const Value: string): TMAPIRecipient;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
  begin
    Result := TMAPIRecipient(inherited Items[I]);
    if AnsiCompareText(Result.Name, Value) = 0 then Exit;
  end;
  Result := nil;
end;

{$IFDEF VER130}
function TMAPIRecipients.GetCollectionOwner: TPersistent;
begin
  Result := GetOwner;
end;
{$ENDIF}

function TMAPIRecipients.GetItem(Index: Integer): TMAPIRecipient;
begin
  Result := TMAPIRecipient(inherited Items[Index]);
end;

function TMAPIRecipients.IsEqual(Value: TMAPIRecipients): Boolean;
var
  I: Integer;
begin
  Result := Count = Value.Count;
  if Result then
    for I := 0 to Count - 1 do
    begin
      Result := TMAPIRecipient(Items[I]).IsEqual(TMAPIRecipient(Value.Items[I]));
      if not Result then Break;
    end
end;

procedure TMAPIRecipients.SetItem(Index: Integer;
  const Value: TMAPIRecipient);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

end.
